#ifndef __DXDRAW_HPP__
#define __DXDRAW_HPP__

/******************************************************************************
    HawkCreek software

    Purpose:
    DirectDraw Interface, responsible for setting the videomode
    only one instance per program is allowed
    needed to create surfaces later on

******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

#ifndef __WINDOWS_H__
#define __WINDOWS_H__
  #ifndef WIN32_LEAN_AND_MEAN
  #define WIN32_LEAN_AND_MEAN
  #endif
#include <windows.h>
#endif

struct IDirectDraw7;

class
cDXDRAW
{
private:

    IDirectDraw7 *DirectDraw; // the main DirectDraw Object (the graphics hardware)
	HWND Window;
	tBOOL FullScreen;

    void Initialize( const HWND &GameWindow, tUINT32 XResolution,
		tUINT32 YResolution, tUINT32 BitDepth, tBOOL FullScreen );

public:

    cDXDRAW( const HWND &GameWindow, tBOOL FullScreen );
    cDXDRAW( const HWND &GameWindow, tUINT32 XResolution, tUINT32 YResolution, tUINT32 BitDepth, tBOOL FullScreen );

    ~cDXDRAW();

    IDirectDraw7 *GetDirectDrawInterface( void ) { return DirectDraw; };
	tBOOL IsFullScreen( void ) { return FullScreen; };
	HWND GetWindow( void ) { return Window; };
    tUINT32 GetTotalVideoMemory( void );
    tUINT32 GetFreeVideoMemory( void );
};

extern cDXDRAW *DirectDraw;

#endif

