#ifndef __PAINT_HPP__
#define __PAINT_HPP__

/******************************************************************************
    HawkCreek software

    Purpose:
    To provide common drawing operations on cSURFACES

******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

class cSURFACE;

class
cPAINT
{
private:

    cSURFACE *Destination;
    tUINT16 *SurfaceMem;
    tUINT32 Pitch;

public:

    cPAINT( void );
    ~cPAINT();

    cSURFACE *SetDrawingTarget( cSURFACE *Dest );
    void BeginDrawing( void );
    void EndDrawing( void );

    void PutPixel( tUINT32 X, tUINT32 Y, tUINT16 Color );
	void DrawRect( tSINT32 X1, tSINT32 Y1, tSINT32 X2, tSINT32 Y2, tUINT16 Color );

    void Fill( tUINT16 Color );
	void Fill( tUINT32 x1, tUINT32 y1, tUINT32 x2, tUINT32 y2, tUINT16 Color );
    void LoadBMP( const char *FileName );
	tBOOL GetBMPDimensions( const char *FileName,
						   tUINT32 *Width,
						   tUINT32*Height );
};

#endif
