#ifndef __SPRITE_HPP__
#define __SPRITE_HPP__

/******************************************************************************
    HawkCreek software

    Purpose:

******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

#ifndef __VECTOR_HPP__
#include "general\vector.hpp"
#endif

#ifndef __MAP_HPP__
#include "Map\map.hpp"
#endif

#include <list>

class
cSPRITE
{
protected:
	tUINT32 TileSet;
	cMAP *Map;

	cVECTOR Position;

public:
    cSPRITE( cMAP *Map, tUINT32 TileSet, cVECTOR Position );
    virtual ~cSPRITE( );

	virtual tUINT32 GetTileSet( );
	virtual tUINT32 GetTileNr( );

	virtual tBOOL SetPosition( cVECTOR Position );
	virtual void GetPosition( cVECTOR *Position );

	virtual void Think( );
};

/******************************************************************************************/

class
cMARINESPRITE : public cSPRITE
{
private:
	tDOUBLE LastAnimTime;	// time in ticks of last animation frame change
	tDOUBLE LastFrameTime;	// time in ticks of previous frame
	tDOUBLE FrameTime;		// time in ticks of current frame
	tDOUBLE FrameDelta;		// time in seconds from last frame
	tUINT32 TileNr;
	tUINT32 TileNrBase;
	tUINT32 SequenceLength;

	enum { Frequency = 15 };		// animation frames per second
	enum { UnitsPerSecond = 70 };	// movement speed in worldunits/second

	tDIRECTION Direction;
	cVECTOR Speed;

	std::list< cVECTOR > Path;

public:
    cMARINESPRITE( cMAP *Map, tUINT32 TileSet, cVECTOR Position );
    ~cMARINESPRITE( ) { };

	tUINT32 GetTileNr( );

	void Think( );
	void Move( cVECTOR To );
};

#endif

