/******************************************************************************
    HawkCreek software

    Purpose:
    Testumgebung fr neue Module
    everything in here is a quick hack to test the seperate modules
    -> it should *not* be used as a base for "the real thing"

    Notes:

    History of Changes:
    - 06.02.1999: file created by BuschnicK
    - 08.03.1999: doesn't restore after a taskswitch, FIXED
******************************************************************************/

#include "general\debug.hpp"
#include "general\helpmacros.hpp"
#include "general\type.hpp"
#include "BlackFish\game.hpp"
#include "resource.h"

#ifndef __WINDOWS_H__
#define __WINDOWS_H__
  #ifndef WIN32_LEAN_AND_MEAN // !! reset this after including windows.h?
  #define WIN32_LEAN_AND_MEAN
  #endif
#include <windows.h>
#endif

// !! Should be read from a resource or so, whatever...
#define NAME    "BuschnicKs"
#define TITLE   "BuschnicKs Test Window"

cGAME *Game = NULL;
tBOOL ApplicationActive = TRUE;
const tBOOL FULLSCREEN = TRUE;

/*
 *
 */
LONG CALLBACK
WindowProcedure( HWND WindowHandle, UINT Message, WPARAM wParam, LPARAM lParam )
{
    switch ( Message )
    {
        case WM_ACTIVATEAPP:
            ApplicationActive = (wParam == WA_ACTIVE) || (wParam == WA_CLICKACTIVE);
            if (( ApplicationActive ) && ( Game != NULL )) // Game is NULL on first activate
				Game->RetrieveFocus( );
        return 0L;

        case WM_CLOSE:
			SAFEDELETE( Game );
            ShutDownLogging();
            PostQuitMessage(0);
        return 0L;

        case WM_SETCURSOR:
            SetCursor( NULL );
        return TRUE;

    }
    return DefWindowProc( WindowHandle, Message, wParam, lParam );
}

/*
 *
 */
void
InitApplication( HINSTANCE hInstance, int nCmdShow )
{
	HWND        WindowHandle;
    WNDCLASS    WindowClass;

    // Set up and register window class
    WindowClass.style            = CS_HREDRAW | CS_VREDRAW;
    WindowClass.lpfnWndProc      = WindowProcedure;
    WindowClass.cbClsExtra       = 0;
    WindowClass.cbWndExtra       = 0;
    WindowClass.hInstance        = hInstance;
    WindowClass.hIcon            = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
    WindowClass.hCursor          = LoadCursor(NULL, IDC_ARROW);
    WindowClass.hbrBackground    = (HBRUSH )GetStockObject(BLACK_BRUSH);
    WindowClass.lpszMenuName     = NAME;
    WindowClass.lpszClassName    = NAME;
    RegisterClass( &WindowClass );

	RECT Client;
	SetRect( &Client, 64, 64, 800 + 64, 600 + 64 );
	AdjustWindowRectEx(
		&Client,
		WS_OVERLAPPEDWINDOW,
		FALSE,
		0 );

    // Now that windows knows about our new type of window create one
    WindowHandle = CreateWindowEx(
        0,//WS_EX_TOPMOST,
        NAME,
        TITLE,
        WS_OVERLAPPEDWINDOW, //WS_POPUP
        Client.left,
        Client.top,
        Client.right - Client.left,
        Client.bottom - Client.top,
        NULL,
        NULL,
        hInstance,
        NULL );

    ASSERT( WindowHandle != NULL );

    ShowWindow( WindowHandle, nCmdShow );
    UpdateWindow( WindowHandle );
    SetFocus( WindowHandle );

    InitLogging( "log.txt" );

	Game = new cGAME( WindowHandle, hInstance, FULLSCREEN );
}

/*
 *
 */
int PASCAL
WinMain(
    HINSTANCE Instance,
    HINSTANCE PreviousInstance,
    LPSTR CommandLine,
    int CommandShow)
{
    // !! Dummies to avoid the 'Not used' warning
    PreviousInstance = PreviousInstance;
    CommandLine      = CommandLine;

    InitApplication( Instance, CommandShow );

    MSG Message;
    for ( ;; )
    {
        if ( PeekMessage( &Message, NULL, 0, 0, PM_NOREMOVE ))
        {
            if ( !GetMessage( &Message, NULL, 0, 0 ))
                return Message.wParam;
            TranslateMessage( &Message );
            DispatchMessage( &Message );
        }
        else if ( ApplicationActive )
        {
			Game->Run( );
        }
        else
        {
            WaitMessage( );
        }
    }
}

