#ifndef __TILESET_HPP__
#define __TILESET_HPP__

/******************************************************************************
    HawkCreek software

    Purpose:
    Loading and managing of an array of cSURFACES

******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

#ifndef __SURFACE_HPP__
#include "BlackFish\Surface.hpp"
#endif

#ifndef __CACHE_HPP__
#include "BlackFish\CACHE.hpp"
#endif

#ifndef __WINDOWS_H__
#define __WINDOWS_H__
  #ifndef WIN32_LEAN_AND_MEAN // !! reset this after including windows.h?
  #define WIN32_LEAN_AND_MEAN
  #endif
#include <windows.h> // !! nur fr RECT ?!
#endif

class cDXDRAW;

class
cTILESET
{
    public:

    tSINT32 TileWidth;                   // should be tUINT32s
    tSINT32 TileHeight;
    tSINT32 SurfaceWidth;
    tSINT32 SurfaceHeight;
    tUINT32 NrOfTiles;
    cSURFACE **Tile;
    cCACHE *Cache;

    public:

    cTILESET( const char *IniFileName, const char *ResourceName );
    ~cTILESET();

    cSURFACE *GetTile( tUINT32 TileNr );
    inline tSINT32 GetTileWidth( void )		{ return TileWidth; };
    inline tSINT32 GetTileHeight( void )	{ return TileHeight; };
    void GetTileRect( RECT *Rectangle );
    inline void SetCache( cCACHE *nCache )	{ Cache = nCache; };
    inline cCACHE *GetCache( void )			{ return Cache; };

    void Blit( tUINT32 TileNr, RECT *SourceRect, cSURFACE *Dest, RECT *DestRect );
    void BlitTrans( tUINT32 TileNr, RECT *SourceRect, cSURFACE *Dest, RECT *DestRect );
};

#endif
