#include "time.hpp"

/******************************************************************************
    HawkCreek software
    Notes:
    History of Changes:
    - 29.03.2000: file created by BuschnicK
 ******************************************************************************/

#include "general\debug.hpp"
#include "general\helpmacros.hpp"
#include "general\type.hpp"

#ifndef __WINDOWS_H__
#define __WINDOWS_H__
  #ifndef WIN32_LEAN_AND_MEAN
  #define WIN32_LEAN_AND_MEAN
  #endif
#include <windows.h>
#endif

cTIMER Timer;

/*
 *
 */
cTIMER::cTIMER( void )
{
	LARGE_INTEGER Temp;
	tBOOL ReturnValue = FALSE;
	ReturnValue = QueryPerformanceFrequency( &Temp );
	ASSERT( ReturnValue != FALSE );
	Frequency = (tDOUBLE) Temp.LowPart;
}

/*
 *
 */
cTIMER::~cTIMER( )
{
}

/*
 * returns the number of ticks since windows start (?)
 * !! the conversion to double loses some precision, but the time to
 *    overflow should still be sufficient
 */
tDOUBLE 
cTIMER::GetTime( void )
{
    __int64 Time;
    QueryPerformanceCounter( ( LARGE_INTEGER * ) &Time );

    return ( tDOUBLE ) Time;
}

