#ifndef __EDITFISH_HPP__
#define __EDITFISH_HPP__

/**************************************************************************
            HawkCreek software


  History of Changes:
  - erstellt am 9.10.1999 von Capella
  - 11.10.1999 first functionality reached
 *************************************************************************/

#include "BlackFish\Blackfish.hpp"

// to prevent includes
class cCACHE;
class cTILESET;
class cWRITE;
class cWALLINFO;
class cCELLINFO;
class cSELECTION;
class cMINIMAP;
class cRETURNDATABASE;

struct tBUTTON
{
	RECT	Rect;
	tBOOL	Active;
};

class cBUTTONARRAY
{
private:
	tBUTTON**	Buttons;
	tUINT32		NrOfButtons;
	void Initialize(const char* IniFileName);
public:
	cBUTTONARRAY(const char* IniFileName);
	~cBUTTONARRAY();
	inline tBUTTON* GetButton(tUINT32 Number){return Buttons[Number];};
	inline tUINT32 GetNrOfButtons() {return NrOfButtons;};
};

class cEDITFISH : public cBLACKFISH
{
    private:

    cBUTTONARRAY *Buttons;
    cTILESET	*MenuTiles;
    tUINT32		 ActiveTilesNr;
    cTILESET	*ActiveTiles;
    tUINT32	 	 VisibleTile;
    tUINT32		 WorkingLayerNr;
    cWALLINFO	*ShowTile;
    tUINT32		 ShowTilePosX, ShowTilePosY;
	tTILESETTYPE ActiveTilesKind; 
	tUINT32		 ActiveNrOfTileSets;
	tUINT32		 CurrentIndexOffset; // is 0, 256, 512 or 768
	cSELECTION	*PaintSelection;
	tBOOL        LeftButtonDown;
	tUINT32		 MouseCellX, MouseCellY;
	tDOUBLE		 StartTime;
	cMINIMAP*	 MiniMap;
	tBOOL		 WasInSelection;
	tBOOL		 SmallWalls;
	
	enum {E_NONE, E_ALL, E_LAYER, E_WALL} EraseMode;
	//cMAP		*Map;


    void PutNewTile ( tSINT32 NewTilePosX, tSINT32 NewTilePosY, tUINT32 NewTileNr, tUINT32 NewTileSetNr );
    cCELLINFO *GetWorkingLayer ( tSINT32 NewTilePosX, tSINT32 NewTilePosY );
    cCELLINFO *GetLayer(tSINT32 NewTilePosX, tSINT32 NewTilePosY, tUINT32 LayerNr);
	//void GetLoadName(char* LoadName);
	void ChangeKind(tBOOL Up = TRUE);
	void ChangeTileSet(tBOOL Up);
	void ChangeTile(tSINT32 TileNr);
	void DeleteWall(tUINT32 PosX, tUINT32 PosY);
	void DeleteShowTileLayer(tUINT32 LayerNr);
	void SetTileSet(tUINT32 TileSetNr);
	void WriteEraseMode(tUINT32 ScreenX, tUINT32 ScreenY);
	void ChangeEraseMode(tBOOL Up);
	void EraseTile(tSINT32 CellX, tSINT32 CellY);
	void UpdateShowTile(tUINT32 PosX, tUINT32 PosY);

    public:
    cEDITFISH(cSURFACE *nSystemBuffer,
              cCACHE *nCache16x16,
              cCACHE *nCache64x32,
              cCACHE *nCache64x128,
              const char *IniFileName);

	~cEDITFISH();

    enum { ScreenWidth = 799, ScreenHeight = 599, ScreenCenterX = 399, ScreenCenterY = 239};
    enum { DataVersion = 1 };
    void Menu(void);
    void MouseClick(tSINT32 MouseX, tSINT32 MouseY, tUINT32 MouseButtonNr);
    void ActivateButton (tUINT32 ButtonNr, tUINT32 MouseButtonNr);
    inline void SetWorkingLayer(tUINT32 nWorkingLayerNr) {WorkingLayerNr=nWorkingLayerNr;};
	void HandleKeyStroke(tUINT8 KeyMessage);
	void NewMapHeader (cRETURNDATABASE* NewMapData);
	void LoadMap(cRETURNDATABASE* Data);
	void SaveMap(cRETURNDATABASE* Data);
	void MouseState(tSINT32 PosX, tSINT32 PosY, tUINT32 Buttons);
	inline tBOOL GetWallState() {return SmallWalls;};
};

#endif
