#include "debug.hpp"

/******************************************************************************
    HawkCreek software
    Notes:
    History of Changes:
    - 11.03.1999: file created by BuschnicK
******************************************************************************/

#include "General\HelpMacros.hpp"

#include <fstream>
#include <cstdlib>                     // exit()

std::ofstream *LOG;

const char DebugFileName[80] = "assert.txt";
const unsigned int MaxAssertionFailures = 1;

/*
 * write an assertion failure to a text file
 */
void 
FileAssert( unsigned int Expression, const char *ErrorFileName, unsigned int ErrorLineNr )
{
    // die wievielte ASSERTION schlgt gerade fehl?
    static unsigned int Counter = 0;
    static std::ofstream OutPutFile( DebugFileName, std::ios_base::out | std::ios_base::trunc );

    // Ist die zu berprfende Bedingung falsch?
    // ja: ffne Datei und schreib wo es schiefgegangen ist
    // nein: do nothing
    if ( Expression == FALSE )
    {
        OutPutFile << "(";
        OutPutFile.width( 5 );
        OutPutFile << Counter << ")" << " An assertion failed in file '" \
			<< ErrorFileName << "', line " << ErrorLineNr << "\n";
        Counter++;
        if ( Counter >= MaxAssertionFailures )
			QUIT;
    }
    // !!! I'm relying on windows here to close the outputfile
}

/*
 * prepare the LOG file output stream, to be called once at program start
 */
void
InitLogging( const char *LogFileName )
{
    LOG = new std::ofstream( LogFileName, std::ios_base::out | std::ios_base::trunc );
//	LOG->setbuf( NULL, 0 );		// !! using C++ standard streams now... find out how to write unbuffered
}

/*
 * delete the LOG file output stream, to be called once at program termination
 */
void
ShutDownLogging( void )
{
    SAFEDELETE( LOG );
}
