#ifndef __HELPMACROS_HPP__
#define __HELPMACROS_HPP__

/******************************************************************************
    HawkCreek software

    Purpose:
    Sammlung von Allzweckmacros, die immer und berall handy sind

    Notes:

    History of Changes:
    - 06.02.1999: file created by BuschnicK
    - 27.02.1999: renamed DELETE to SAFEDELETE because DELETE was
                  already defined somewhere in the win***.h files...
    - 14.03.1999: !!! should check 'release()' return value, cause it might not be safe
		  to set the pointer to NULL - there might still be references to that
 		  object left
*****************************************************************************/

#include "general\type.hpp"
#include "general\debug.hpp"

#define RELEASE( PointerVariable )          \
{                                           \
    ASSERT( PointerVariable != NULL );      \
    PointerVariable->Release();             \
    PointerVariable = NULL;                 \
} // !!! PointerVariable = NULL?! Nach Release() knnen eventuell immer noch references auf objekt vorhanden sein
  // !!! ASSERT() PointerVariable != NULL; doesn't seem to trigger

#define SAFEDELETE( PointerVariable )       \
{                                           \
    if ( PointerVariable != NULL )          \
    {                                       \
        delete PointerVariable;				\
        PointerVariable = NULL;             \
    }                                       \
}

#define SAFEDELETEARRAY( PointerVariable )	\
{											\
    if ( PointerVariable != NULL )          \
    {                                       \
        delete [] PointerVariable;			\
        PointerVariable = NULL;             \
    }                                       \
}

#define QUIT exit( EXIT_FAILURE );

#endif
