#ifndef __TYPE_HPP__
#define __TYPE_HPP__

/******************************************************************************
    BuschnicK software                                                8.11.1998

    Purpose:
    Header file to declare commonly used data types like integer and floating point
    numbers. Used so that names are consistent and shorter, i.e. tUINT32 instead of
    unsigned int. Also useful for porting the system to another compiler/processor
    which might use different names/sizes.
    This header should be included by every file in the project and the declared
    data types must always be used instead of the compiler/language default.

    History of Changes:
    - 08.11.1998: file created by BuschnicK
    - 09.02.1999: BuschnicK added the type modifier #defines
    - 25.02.1999: BuschnicK added 'STATIC' type modifier
                  deleted 'NIL' cause it was somewhat redundant (use NULL instead)
    - 27.02.1999: FUCK Windows.h! Das Scheiteil hat alle meine #define und typedef
                  namen benutzt! Ich hab jetzt #ifndef etc um meine gemacht, ist
                  aber gefhrlich, da windows die typen teilweise leicht anders
                  deklariert... Die ganzen win***.h Dateien sind voll mit macros,
                  die sich teilweise schon gegenseitig berschneiden, z.B. VOID,
                  auerdem versuch z.B. mal den typ von HWND ber die Headerdateien
                  herauszufinden, das ist ne Endlosjagd... Alles Scheisse!
                  - hab #define VOID gestrichen (wegen der windows.h problems)
                  - hab BOOL in tBOOL gendert    ( "   "     "         "    )
                  - hab typedef CHAR gestrichen   ( "   "     "         "    )
                  - hab CONST, STATIC und VOLATILE entfernt ( " " "     "    )
	- 18.03.2000: allen Typen ein t vorangestellt
******************************************************************************/

/*
 * Names are all capital letters and consist of:
 * prefix: U for unsigned, S for signed
 * name: INT for integer
 * suffix: 8,16,32 to represent the size of this data type in bits
 */
typedef unsigned char           tUINT8;  //           0..255
typedef signed char             tSINT8;  //        -128..127
typedef unsigned short int      tUINT16; //           0..65535
typedef signed short int        tSINT16; //      -32768..32767
typedef unsigned long int       tUINT32; //           0..4294967295
typedef signed long int         tSINT32; // -2147483648..2147483647

/*
 * Special, non-integer types:
 * floating point numbers, characters, BOOLEAN
 */
// tFLOAT, smallest absolute value 1.1E-38, largest absolute value 3.4E+38, digits of accuracy 6
typedef float                   tFLOAT;

// tDOUBLE, smallest absoulte value 2.2E-308, largest absolute value 1.7E+308, digits of accuracy 15
typedef double                  tDOUBLE;

typedef tSINT32                  tBOOL; // boolean type, should only accept values of 1 TRUE, and 0 FALSE

/*
 * Special constant definitions
 */
#ifndef TRUE    // !! Dangerous, but has to be because of windows...
#define TRUE                    1
#endif
#ifndef FALSE   // !!
#define FALSE                   0
#endif
#ifndef NULL    // !!
#define NULL                    0L      // the null-pointer value
#endif

#endif
