#include "Vector.hpp"

/******************************************************************************
    HawkCreek software
    Notes:
    History of Changes:
    - 20.03.2000: file created by BuschnicK
	- 16.10.2000: rewrite this, using operator overloading to make 
				  calculations look more natural and intuitive
 ******************************************************************************/

#include <math.h>

/*
 *
 */
cMATRIX3x3::cMATRIX3x3( void )
{
	Set( 1, 0, 0,
		 0, 1, 0,
		 0, 0, 1 );
}

/*
 *
 */
cMATRIX3x3::cMATRIX3x3( tFLOAT x1, tFLOAT y1, tFLOAT z1,
						tFLOAT x2, tFLOAT y2, tFLOAT z2,
						tFLOAT x3, tFLOAT y3, tFLOAT z3 )
{
	Set( x1, y1, z1, 
		 x2, y2, z2, 
		 x3, y3, z3 );
}

/*
 *
 */
void
cMATRIX3x3::Set( tFLOAT x1, tFLOAT y1, tFLOAT z1,
				 tFLOAT x2, tFLOAT y2, tFLOAT z2,
				 tFLOAT x3, tFLOAT y3, tFLOAT z3 )
{
	this->x1 = x1; this->y1 = y1; this->z1 = z1;
	this->x2 = x2; this->y2 = y2; this->z2 = z2;
	this->x3 = x3; this->y3 = y3; this->z3 = z3;
}

/*
 *
 */
cVECTOR::cVECTOR( void )
{
	Set( 0, 0, 0 );
}

/*
 *
 */
cVECTOR::cVECTOR( tFLOAT x, tFLOAT y, tFLOAT z )
{
	Set( x, y, z );
}

/*
 *
 */
void 
cVECTOR::Set( tFLOAT x, tFLOAT y, tFLOAT z )
{
	this->x = x;
	this->y = y;
	this->z = z;
}

/*
 *
 */
void 
cVECTOR::Set( cVECTOR Vector )
{
	this->x = Vector.x;
	this->y = Vector.y;
	this->z = Vector.z;
}

/*
 *
 */
void 
cVECTOR::Multiply( cMATRIX3x3 *Matrix, cVECTOR *Vector )
{
	x = Vector->x * Matrix->x1 + Vector->y * Matrix->x2 + Vector->z * Matrix->x3;
	y = Vector->x * Matrix->y1 + Vector->y * Matrix->y2 + Vector->z * Matrix->y3;
	z = Vector->x * Matrix->z1 + Vector->y * Matrix->z2 + Vector->z * Matrix->z3;
}

/*
 *
 */
void 
cVECTOR::Multiply( tFLOAT Skalar )
{
	x *= Skalar;
	y *= Skalar;
	z *= Skalar;
}

/*
 * 
 */
void
cVECTOR::Add( cVECTOR Vector )
{
	x += Vector.x;
	y += Vector.y;
	z += Vector.z;
}

/*
 * 
 */
void
cVECTOR::Subtract( cVECTOR Vector )
{
	x -= Vector.x;
	y -= Vector.y;
	z -= Vector.z;
}

/*
 *
 */
tFLOAT
cVECTOR::GetLength( void )
{
	return ((tFLOAT) sqrt( x*x + y*y + z*z ));
}

/*
 *
 */
void
cVECTOR::Normalize( void )
{
	tFLOAT Length = GetLength( );
	if ( Length )
	{
		x /= Length;
		y /= Length;
		z /= Length;
	}
}

/*
 *
 */
tBOOL
cVECTOR::Equals( cVECTOR Vector )
{
	const tFLOAT TOLERANCE = 0.02f; // float values can't be compared exactly

	tBOOL ReturnValue = FALSE;
	ReturnValue = ( fabs( Vector.x - x ) < TOLERANCE );
	ReturnValue = ( fabs( Vector.y - y ) < TOLERANCE ) && ReturnValue; 
	ReturnValue = ( fabs( Vector.z - z ) < TOLERANCE ) && ReturnValue;
	return ReturnValue;
}
