#ifndef __VECTOR_HPP__
#define __VECTOR_HPP__

/******************************************************************************
    HawkCreek software

    Purpose:

    History of Changes:
    - 20.03.2000: file created by BuschnicK
	- 30.03.2000: added Normalize(), Add(), Multiply(), GetLength()
	- 03.04.2000: changed cVECTOR2D to cVECTOR and cMATRIX2x2 to cMATRIX3x3 so
				  everything works in R now
******************************************************************************/

#ifndef __TYPE_HPP__
#include "general\type.hpp"
#endif

class
cMATRIX3x3
{
public:

	tFLOAT x1, y1, z1,
		   x2, y2, z2,
		   x3, y3, z3;

public:

	cMATRIX3x3( void );
	cMATRIX3x3( tFLOAT x1, tFLOAT y1, tFLOAT z1,
				tFLOAT x2, tFLOAT y2, tFLOAT z2,
				tFLOAT x3, tFLOAT y3, tFLOAT z3 );
	
	void Set( tFLOAT x1, tFLOAT y1, tFLOAT z1,
			  tFLOAT x2, tFLOAT y2, tFLOAT z2,
			  tFLOAT x3, tFLOAT y3, tFLOAT z3 );
};

class
cVECTOR
{
public:

	tFLOAT x, y, z;

public:

	cVECTOR( void );
	cVECTOR( tFLOAT x, tFLOAT y, tFLOAT z );

	void Set( tFLOAT x, tFLOAT y, tFLOAT z );
	void Set( cVECTOR Vector );
	void Multiply( cMATRIX3x3 *Matrix, cVECTOR *Vector );
	void Multiply( tFLOAT Skalar );
	void Add( cVECTOR Vector );
	void Subtract( cVECTOR Vector );
	void Normalize( void );
	tBOOL Equals( cVECTOR Vector );
	tFLOAT GetLength( void );
};

#endif