//--- Specific File Includes ----//
#include "Include File.h"


//Function to Generate a new city
void CITY::CityGen(int x, int y, int player_num)
{
	int city_number;
	int i = 0;
	bool notDone = TRUE;

	//find the first city[city_number].exists that is not does not exist yet
	while (notDone)
	{
		if (!city[i].exists) //stop the loop when you find an empty spot to use for a city
		{
			notDone = FALSE;
			city_number = i;
		}

		i++;

		if (i == 999)
			notDone = FALSE;
	}	

	city[city_number].x_tile = x;    //store the tile location of the city
	city[city_number].y_tile = y;

	city[city_number].exists = TRUE; //now this city exists

	//tell the tile there is a city there, and which city it is
	tile[x][y].city	= city_number;

	//what player owns the city
	city[city_number].player_number = player_num;  //either player 0 or player 1

	//what image is the city to display
	city[city_number].city_image_number = rand () % 2;  //either type elven or human

	//create the outline around the city
	if ((x % 2) == 1) //if the column is odd
	{
		tile[x][y-2]  .Hex_Outline = 0;
		tile[x-1][y-1].Hex_Outline = 1;
		tile[x-2][y-1].Hex_Outline = 2;
		tile[x-2][y]  .Hex_Outline = 3;
		tile[x-2][y+1].Hex_Outline = 4;
		tile[x-1][y+2].Hex_Outline = 5;
		tile[x][y+2]  .Hex_Outline = 6;
		tile[x+1][y+2].Hex_Outline = 7;
		tile[x+2][y+1].Hex_Outline = 8;
		tile[x+2][y]  .Hex_Outline = 9;
		tile[x+2][y-1].Hex_Outline = 10;
		tile[x+1][y-1].Hex_Outline = 11;
	}
	else
	{
		tile[x][y-2]  .Hex_Outline = 0;
		tile[x-1][y-2].Hex_Outline = 1;
		tile[x-2][y-1].Hex_Outline = 2;
		tile[x-2][y]  .Hex_Outline = 3;
		tile[x-2][y+1].Hex_Outline = 4;
		tile[x-1][y+1].Hex_Outline = 5;
		tile[x][y+2]  .Hex_Outline = 6;
		tile[x+1][y+1].Hex_Outline = 7;
		tile[x+2][y+1].Hex_Outline = 8;
		tile[x+2][y]  .Hex_Outline = 9;
		tile[x+2][y-1].Hex_Outline = 10;
		tile[x+1][y-2].Hex_Outline = 11;
	}



	//do player/race specific city setups here
	switch (player_num)
	{
		case ePlayer_0:  //Player 0 is blue

			//also do any other city set ups here there will be specific to race
			//like the Hive in smac gets a free a perimeter defense, it would go be
			//initilized here

			break;

		case ePlayer_1:  //Player 1 is white

			//also do any other city set ups here there will be specific to race
			//like the Hive in smac gets a free a perimeter defense, it would go be
			//initilized here

			break;
	}

	//set up the city here, like food, population, production ect...
	city[city_number].population = 1;

	city[city_number].gold_generation = 1;

	city[city_number].net_gold_generation = 1;


	//remove the fog of war around the city
	Fog_Of_War_Functions.Generic(x, y, 2);
}



void CITY::BuildCity(int BuildCityMethod)
{
	//If BuildMethod = eBKey, then the 'b' key was pressed, so check if the city can be built here and check if a unit was selected
	//                        and check if that unit can build cities
	//If BuildMethod > 0, then a method like a spell was used, so check if the city can be built here then

	//Build City Methods
	//enum {eCantBuild, eBuildCity, eBuildCitySpell, eBuildUnderGroundCity, eBuildMtCity, eBuildSwampCity, eBuildWaterCity, eBuildWastelandCity. 
	//	    eBuildAnyTerrainCity, eBuildSkyCity, eBuildAnyTerrainCitySpell};

	//Terrain Types
	//enum {eTILE_TYPE_GRASS, eTILE_TYPE_DESERT, eTILE_TYPE_WASTE, eTILE_TYPE_SWAMP, eTILE_TYPE_MT, eTILE_TYPE_JUNGLE, eTILE_TYPE_HILL,
	//	    eTILE_TYPE_PRAIRE, eTILE_TYPE_SHALLOWWATER, eTILE_TYPE_DEEPWATER, eTILE_TYPE_SKY};

	bool bBuildIt = FALSE;
	bool bUnitMethod = FALSE;
	
	//if the eBuildCity method, check if the unit can do it
	if (BuildCityMethod == eBuildCity && unit_types[unit[Unit_Vars.selected_unit].unit_type].BuildCityMethod == eBuildCity && unit[Unit_Vars.selected_unit].player_number == Game_Globals.current_player)
	{
		int x = unit[Unit_Vars.selected_unit].x_tile;
		int y = unit[Unit_Vars.selected_unit].y_tile;

		//check if the tile already has a city in it
		if (tile[x][y].city == -1)
		{
			//then check the tile type
			if (tile[x][y].type == eTILE_TYPE_GRASS || tile[x][y].type == eTILE_TYPE_DESERT || tile[x][y].type == eTILE_TYPE_HILL ||
				tile[x][y].type == eTILE_TYPE_PRAIRE || tile[x][y].type == eTILE_TYPE_JUNGLE)
			{
				//then check for other things, like if there are terrain inprovements or other structures there
				//if (tile[x][y].structure > -1)
				//{
				//}

				//now build the city
				bBuildIt = TRUE;
				bUnitMethod = TRUE;
			}
		}
	}


	//if the eBuildCity method, check if the unit can do it
	else if (BuildCityMethod == eBuildSwampCity && unit_types[unit[Unit_Vars.selected_unit].unit_type].BuildCityMethod == eBuildSwampCity && unit[Unit_Vars.selected_unit].player_number == Game_Globals.current_player)
	{
		int x = unit[Unit_Vars.selected_unit].x_tile;
		int y = unit[Unit_Vars.selected_unit].y_tile;

		//check if the tile already has a city in it
		if (tile[x][y].city == -1)
		{
			//then check the tile type
			if (tile[x][y].type == eTILE_TYPE_GRASS || tile[x][y].type == eTILE_TYPE_DESERT || tile[x][y].type == eTILE_TYPE_HILL || 
				tile[x][y].type == eTILE_TYPE_PRAIRE || tile[x][y].type ==eTILE_TYPE_JUNGLE || tile[x][y].type == eTILE_TYPE_SWAMP)
			{
				//then check for other things, like if there are terrain inprovements or other structures there
				//if (tile[x][y].structure > -1)
				//{
				//}

				//now build the city
				bBuildIt = TRUE;
				bUnitMethod = TRUE;
			}
		}
	}


	//else if  //other methods ect...
	//{
	//}



	//Now if bBuildIt == TRUE, then you actually make the city
	if (bBuildIt)
	{
		int city_number;
		int i = 0;
		bool notDone = TRUE;

		int x = unit[Unit_Vars.selected_unit].x_tile; //get the city location
		int y = unit[Unit_Vars.selected_unit].y_tile;


		//find the first city[city_number].exists that is not does not exist yet
		while (notDone)
		{
			if (!city[i].exists) //stop the loop when you find an empty spot to use for a city
			{
				notDone = FALSE;
				city_number = i;
			}

			i++;

			if (i == 999)
				notDone = FALSE;
		}	

		city[city_number].x_tile = x;    //store the tile location of the city
		city[city_number].y_tile = y;

		city[city_number].exists = TRUE; //now this city exists

		//tell the tile there is a city there, and which city it is
		tile[x][y].city	= city_number;

		//what player owns the city
		city[city_number].player_number = Game_Globals.current_player;  //either player 0 or player 1

		//what image is the city to display
		city[city_number].city_image_number = rand () % 2;  //either type elven or human

		//create the outline around the city
		if ((x % 2) == 1) //if the column is odd
		{
			tile[x  ][y-2].Hex_Outline = 0;
			tile[x-1][y-1].Hex_Outline = 1;
			tile[x-2][y-1].Hex_Outline = 2;
			tile[x-2][y  ].Hex_Outline = 3;
			tile[x-2][y+1].Hex_Outline = 4;
			tile[x-1][y+2].Hex_Outline = 5;
			tile[x  ][y+2].Hex_Outline = 6;
			tile[x+1][y+2].Hex_Outline = 7;
			tile[x+2][y+1].Hex_Outline = 8;
			tile[x+2][y  ].Hex_Outline = 9;
			tile[x+2][y-1].Hex_Outline = 10;
			tile[x+1][y-1].Hex_Outline = 11;
		}
		else
		{
			tile[x  ][y-2].Hex_Outline = 0;
			tile[x-1][y-2].Hex_Outline = 1;
			tile[x-2][y-1].Hex_Outline = 2;
			tile[x-2][y  ].Hex_Outline = 3;
			tile[x-2][y+1].Hex_Outline = 4;
			tile[x-1][y+1].Hex_Outline = 5;
			tile[x  ][y+2].Hex_Outline = 6;
			tile[x+1][y+1].Hex_Outline = 7;
			tile[x+2][y+1].Hex_Outline = 8;
			tile[x+2][y  ].Hex_Outline = 9;
			tile[x+2][y-1].Hex_Outline = 10;
			tile[x+1][y-2].Hex_Outline = 11;
		}


		//do player/race specific city setups here
		switch (Game_Globals.current_player)
		{
			case ePlayer_0:  //Player 0 is blue

				//also do any other city set ups here there will be specific to race
				//like the Hive in smac gets a free a perimeter defense, it would go be
				//initilized here

				break;

			case ePlayer_1:  //Player 1 is white

				//also do any other city set ups here there will be specific to race
				//like the Hive in smac gets a free a perimeter defense, it would go be
				//initilized here

				break;
		}


		
		//set up the city here, like food, population, production ect...
		city[city_number].population = 3;
		city[city_number].current_production = eSETTLER;
		city[city_number].resources_added_this_turn = 2.0;
		city[city_number].gold_added_this_turn		= 5.0;
		city[city_number].mana_added_this_turn		= 2.0;
		city[city_number].labor_added_this_turn		= 1.0;

		city[city_number].gold_generation = 1;

		city[city_number].net_gold_generation = 1;


		//remove the fog of war around the city
		Fog_Of_War_Functions.Generic(x, y, 2);


	}

	if (bUnitMethod)   //if a unit was used to make the city, then the unit is no more, so select the next unit
	{
		unit[Unit_Vars.selected_unit].DestroyUnit(Unit_Vars.selected_unit);
	
		//remove the fog of war around the city
		Fog_Of_War_Functions.Generic(unit[Unit_Vars.selected_unit].x_tile, unit[Unit_Vars.selected_unit].y_tile, 2);
	}
}


void CITY::Production()
{

}







int CITY::GetVisionRange()//return the cities vision range
{
	int range = 2; //the base city range
	
	//check for other effects on the city like spells or city improvements that increase vision range

	return range;
}



