// City.h: interface for the CITY class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_CITY_H__ABC16C33_94E6_486A_A8D8_227C2E361B17__INCLUDED_)
#define AFX_CITY_H__ABC16C33_94E6_486A_A8D8_227C2E361B17__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

class CITY{      //each and every city has its own struct
public:
	void CityGen(int x, int y, int player_num);  //when a new city is created, this is the function to call
	void BuildCity(int BuildCityMethod);

	int		GetVisionRange();//return the cities vision range

	bool	exists;
	
	int		player_number;		//which player does the city belong too

	int		x_tile;			//what tile the city is in
	int		y_tile;

	// city_surf[city[tile[i][j].city].city_image_number]  for blitting
	int		city_image_number;   //this number is based on the city size and city race

	//the city
	int		population;   //the size of the city (total size)
	int		race;		// the main race type of the city (for the picture, as well as other things)

	//what is the demographics of the city (population break down)
	int		elven_population;	//how much of the population is elven
	bool	elven_slaves;		//are they slaves? TRUE if they are slaves, FALSE if they are not
	int		elven_happy;
	int		elven_content;		//the amount of the elven population in the city that is happy, content
	int		elven_unrully;		//unrully. or revolting (only slaves will revolt)
	int		elven_revolting;

	int		halfling_population;//how much of the population is halfling
	bool	halfling_slaves;	//are they slaves? TRUE if they are slaves, FALSE if they are not
	int		halfling_happy;
	int		halfling_content;
	int		halfling_unrully;
	int		halfling_revolting;

	int		orc_population;		//how much of the population is orc
	bool	orc_slaves;			//are they slaves? TRUE if they are slaves, FALSE if they are not
	int		orc_happy;
	int		orc_content;
	int		orc_unrully;
	int		orc_revolting;

	int		goblin_population;	//how much of the population is goblin
	bool	goblin_slaves;		//are they slaves? TRUE if they are slaves, FALSE if they are not
	int		goblin_happy;
	int		goblin_content;
	int		goblin_unrully;
	int		goblin_revolting;

	int		human_population;	//how much of the population is human
	bool	human_slaves;		//are they slaves? TRUE if they are slaves, FALSE if they are not
	int		human_happy;
	int		human_content;
	int		human_unrully;
	int		human_revolting;

	int		dwarven_population;	//how much of the population is dwarven
	int		dwarven_slaves;		//are they slaves? TRUE if they are slaves, FALSE if they are not
	int		dwarven_happy;
	int		dwarven_content;
	int		dwarven_unrully;
	int		dwarven_revolting;


	//Gold/Mana/Resource/Labor produced per turn
	float	gold_generation;		//amount of gold the city will produce this turn
	float	net_gold_generation;	//gold_generation - gold_added_this_turn;

	float	mana_generation;		//amount of mana the city will produce this turn
	float	net_mana_generation;	//mana_generation - mana_added_this_turn;

	float	resource_generation;	//amount of resources the city will produce this turn
	float	net_resource_generation;//resource_generation - resources_added_this_turn;

	float	labor_generation;		//units of population sent to work on the current production
	//labor is not accumulated, it is either used durning the turn or wasted


	//CITY PRODUCTION
	//what is the city making?
	int		current_production;	//the number of the building
	//Resources
	float	resources_required;	//the amount of resources needed
	float	resources_added;	//the amount of resources already put into the project
	float	resources_added_this_turn;	//the amount that will be added this turn
	//Gold
	float	gold_required;	//the amount of gold needed
	float	gold_added;		//the amount of gold already put into the project
	float	gold_added_this_turn;	//the amount that will be added this turn
	//Mana
	float	mana_required;	//the amount of mana needed
	float	mana_added;		//the amount of mana already put into the project
	float	mana_added_this_turn;	//the amount that will be added this turn
	//Labor
	float	labor_required;	//the amount of labor needed
	float	labor_added;	//the amount of labor already put into the project
	float	labor_added_this_turn;	//the amount that will be added this turn



	//City Resource Pool
	float	resource_pool;	//resources are stored at each city, mana and gold are store in the 
							//imperial pool.
							//excess gold and mana produced each turn will is sent to the imperial pool
	
	//Public Works percentage
	float	public_works;	//this is a number between 0 and 1 for what percentage of the resources each
							//turn are sent to the imperial public works
	bool	bPublic_works_affect; //if this is sent to TRUE, then the amount that is sent to the imperial
								  //pool each turn is <resource_generation * public_works>
								  //if this is sent to FALSE, then the amount that is sent to the imperial 
								  //pool each turn is <net_resource_generation>
								  //this is so the player can set to give all excess resources to the
								  //imperial pool each turn.


	//list structures in it
	bool	market;
	bool	barracks;
	bool	city_walls;
	bool	temple;
	bool	aquaduct;
	bool	stables;
	bool	archery_range;
	//ect...


//-----------------------------------------------------------------------------------------------------------------//
	//CITY FUNCTIONS

	void Production();





};
extern class CITY city[1000];


#endif // !defined(AFX_CITY_H__ABC16C33_94E6_486A_A8D8_227C2E361B17__INCLUDED_)
