// CITY_VARIABLES.cpp: implementation of the CITY_VARIABLES class.
//
//////////////////////////////////////////////////////////////////////

#include "Include File.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CITY_VARIABLES::CITY_VARIABLES()
{
	city_image_width = 48;
	city_image_height = 52;
}

CITY_VARIABLES::~CITY_VARIABLES()
{
	SafeRelease (city_surf[0]);
	SafeRelease (city_surf[1]);
	for (int i = 0; i < NUM_TILE_OUTLINES; i++)
		SafeRelease (Hex_Outline_surf[i]);

}



void CITY_VARIABLES::Load_Images()
{
//------------ load the city images ------------------------------------------------//
	city_surf[0] = bitmap_surface("city human.bmp");//&the rct gets the deminsions of the image
	if (!city_surf[0])
	{
		ErrStr=Err_LoadImageCity;
	}

	city_surf[1] = bitmap_surface("city elven.bmp");//&the rct gets the deminsions of the image
	if (!city_surf[1])
	{
		ErrStr=Err_LoadImageCity;
	}
//------------- LOAD TILE OUTLINES -------------------------------------------------//
	Hex_Outline_surf[eHex_Outline1] = bitmap_surface("Hex Outline 1.bmp");
	if(!Hex_Outline_surf[eHex_Outline1])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline2] = bitmap_surface("Hex Outline 2.bmp");
	if(!Hex_Outline_surf[eHex_Outline2])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline3] = bitmap_surface("Hex Outline 3.bmp");
	if(!Hex_Outline_surf[eHex_Outline3])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline4] = bitmap_surface("Hex Outline 4.bmp");
	if(!Hex_Outline_surf[eHex_Outline4])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline5] = bitmap_surface("Hex Outline 5.bmp");
	if(!Hex_Outline_surf[eHex_Outline5])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline6] = bitmap_surface("Hex Outline 6.bmp");
	if(!Hex_Outline_surf[eHex_Outline6])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline7] = bitmap_surface("Hex Outline 7.bmp");
	if(!Hex_Outline_surf[eHex_Outline7])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline8] = bitmap_surface("Hex Outline 8.bmp");
	if(!Hex_Outline_surf[eHex_Outline8])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline9] = bitmap_surface("Hex Outline 9.bmp");
	if(!Hex_Outline_surf[eHex_Outline9])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline10] = bitmap_surface("Hex Outline 10.bmp");
	if(!Hex_Outline_surf[eHex_Outline10])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline11] = bitmap_surface("Hex Outline 11.bmp");
	if(!Hex_Outline_surf[eHex_Outline11])
	{
		ErrStr=Err_LoadImage;
	}

	Hex_Outline_surf[eHex_Outline12] = bitmap_surface("Hex Outline 12.bmp");
	if(!Hex_Outline_surf[eHex_Outline12])
	{

		ErrStr=Err_LoadImage;
	}




//************************************************************************
	//get the pixel format
	DDPIXELFORMAT ddpf;
	ddpf.dwSize = sizeof(ddpf);
	lpDDSPrimary->GetPixelFormat (&ddpf);

	//Determine proper key for pixel format
	KeyColor = ddpf.dwGBitMask;        //the G is for pure green, which is the color that gets replaced

	//set the color key
	DDCOLORKEY key;
	key.dwColorSpaceLowValue = KeyColor;
	key.dwColorSpaceHighValue = KeyColor;
	
	city_surf[0]->SetColorKey(DDCKEY_SRCBLT, &key);
	city_surf[1]->SetColorKey(DDCKEY_SRCBLT, &key);

	for (int i = 0; i < NUM_TILE_OUTLINES; i++)
		Hex_Outline_surf[i]->SetColorKey(DDCKEY_SRCBLT, &key);
}
