//--- Specific File Includes ----//
#include "Include File.h"


void FOGOFWAR_FUNCTIONS::Move_To(int x, int y)	//this function is called when a unit is moved to this tile
{
	int radius;
	int for_loop;


	//First determine how many units are in this tile
	int num_units = 1; //= ?????  set to 1 for now

	//then cycle through the viewing range of all the units in the tile
	for (int i = 0; i < num_units; i++)
	{
		//then get the units viewing range
		radius = unit[tile[x][y].unit_number].GetVisionRange();
		for_loop = radius;
		
		Generic(x, y, radius);
	}

	//now setup the seperate maps of fog of war for the specific player
	Map_Update(x, y, radius);
}




void FOGOFWAR_FUNCTIONS::Move_From(int x, int y, int unit_number)	//this function is called when a unit is moved out of this tile
{
	int radius;
	int for_loop;
	int x_offset;
	int y_offset;

	
	//First thing is to turn on the fog of war on all tiles within a maxium viewing range, then check to see if there are any units within
	//double maxium viewing range - 1 that can still possible see into the area that was made fog of war 

	//TURN ON FOG OF WAR
	//then get the units viewing range
	radius = unit[unit_number].GetVisionRange();
	for_loop = radius;
	
	for (x_offset = 0; x_offset <= for_loop; x_offset++)
	{
		for (y_offset = 0; y_offset <= radius; y_offset++)
		{
			FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].fog_of_war = TRUE;
			FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].fog_of_war = TRUE;
			FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].fog_of_war = TRUE;
			FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].fog_of_war = TRUE;
		}



		if ((x_offset % 2) == 1) //if the offset spot is odd, then there is another hex to worry about
		{
			if ((x % 2) == 1) //if the column is odd
			{
				FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].fog_of_war = TRUE;
				FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].fog_of_war = TRUE;					
			}
			else
			{
				FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].fog_of_war = TRUE;
				FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].fog_of_war = TRUE;
			}
		}

		if ((x_offset % 2) == 0) //if the x_offset is even, then decrease the radius by 1
			radius--;
	}






	//TURN OFF FOG OF WAR
	//now that the FogofWar is turned back on in that area, then check for units in that 10 hex radius
	int max_viewing_range = 5;
	radius = unit[tile[x][y].unit_number].GetVisionRange() + max_viewing_range -1;
	for_loop = radius;
	
	for (x_offset = 0; x_offset <= for_loop; x_offset++)
	{
		for (y_offset = 0; y_offset <= radius; y_offset++)
		{
			if (tile[x + x_offset][y + y_offset].unit_number > -1)
				if (unit[tile[x + x_offset][y + y_offset].unit_number].player_number == Game_Globals.current_player)
					Move_To(x + x_offset, y + y_offset); //recursive loop here
			if (tile[x + x_offset][y - y_offset].unit_number > -1)
				if (unit[tile[x + x_offset][y - y_offset].unit_number].player_number == Game_Globals.current_player)
					Move_To(x + x_offset, y - y_offset); //recursive loop here
			if (tile[x - x_offset][y + y_offset].unit_number > -1)
				if (unit[tile[x - x_offset][y + y_offset].unit_number].player_number == Game_Globals.current_player)
					Move_To(x - x_offset, y + y_offset); //recursive loop here
			if (tile[x - x_offset][y - y_offset].unit_number > -1)
				if (unit[tile[x - x_offset][y - y_offset].unit_number].player_number == Game_Globals.current_player)
					Move_To(x - x_offset, y - y_offset); //recursive loop here
		}



		if ((x_offset % 2) == 1) //if the offset spot is odd, then there is another hex to worry about
		{
			if ((x % 2) == 1) //if the column is odd
			{
				if (tile[x + x_offset][y + radius + 1].unit_number > -1)
					if (unit[tile[x + x_offset][y + radius + 1].unit_number].player_number == Game_Globals.current_player)
						Move_To(x + x_offset, y + radius + 1); //recursive loop here
				if (tile[x - x_offset][y + radius + 1].unit_number > -1)
					if (unit[tile[x - x_offset][y + radius + 1].unit_number].player_number == Game_Globals.current_player)
						Move_To(x - x_offset, y + radius + 1); //recursive loop here
			}
			else
			{
				if (tile[x + x_offset][y - radius - 1].unit_number > -1)
					if (unit[tile[x + x_offset][y - radius - 1].unit_number].player_number == Game_Globals.current_player)
						Move_To(x + x_offset, y - radius - 1); //recursive loop here
				if (tile[x - x_offset][y - radius - 1].unit_number > -1)
					if (unit[tile[x - x_offset][y - radius - 1].unit_number].player_number == Game_Globals.current_player)
						Move_To(x - x_offset, y - radius - 1); //recursive loop here
			}
		}

		if ((x_offset % 2) == 0) //if the x_offset is even, then decrease the radius by 1
			radius--;
	}

	//now setup the seperate maps of fog of war for the specific player
	Map_Update(x, y, unit[unit_number].GetVisionRange());
}









void FOGOFWAR_FUNCTIONS::Begining_Turn_Update()	//this function is called at the begining of every turn
{	
	//cycle through all the tiles on the map, and update the fog of war
	for (int x = 0; x < map_width; x++)
	{
		for (int y = 0; y < map_height; y++)
		{
			FogOfWar[x][y][Game_Globals.current_player].fog_of_war = TRUE; //turn on the fog of war in the tile then check to remove it
		}
	}


	//cycle through all the tiles on the map, and update the fog of war
	for (x = 0; x < map_width; x++)
	{
		for (int y = 0; y < map_height; y++)
		{			
			//cycle through all the units on the tile
			if (tile[x][y].unit_number > -1)
				if (unit[tile[x][y].unit_number].player_number == Game_Globals.current_player)
					Move_To(x, y);

			//then check if there is a city on the tile
			if (tile[x][y].city > -1)
				if (city[tile[x][y].city].player_number == Game_Globals.current_player)
					Generic(x, y, city[tile[x][y].city].GetVisionRange());
		}
	}
}








void FOGOFWAR_FUNCTIONS::Generic(int x, int y, int radius)
{
	int for_loop = radius;
	int x_offset;
	int y_offset;


	for (x_offset = 0; x_offset <= for_loop; x_offset++)
	{
		for (y_offset = 0; y_offset <= radius; y_offset++)
		{
			FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].black = FALSE;
			FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].black = FALSE;
			FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].black = FALSE;
			FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].black = FALSE;

			FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].fog_of_war = FALSE;
			FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].fog_of_war = FALSE;
			FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].fog_of_war = FALSE;
			FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].fog_of_war = FALSE;
		}



		if ((x_offset % 2) == 1) //if the offset spot is odd, then there is another hex to worry about
		{
			if ((x % 2) == 1) //if the column is odd
			{
				FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].black = FALSE;
				FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].black = FALSE;

				FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].fog_of_war = FALSE;
				FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].fog_of_war = FALSE;					
			}
			else
			{
				FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].black = FALSE;
				FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].black = FALSE;
			
				FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].fog_of_war = FALSE;
				FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].fog_of_war = FALSE;
			}
		}

		if ((x_offset % 2) == 0) //if the x_offset is even, then decrease the radius by 1
			radius--;
	}
}










void FOGOFWAR_FUNCTIONS::Map_Update(int x, int y, int radius)
{
	//set these for radius for the current player
	int for_loop = radius;
	int x_offset;
	int y_offset;


	//DO A CHECK HERE TO SEE IF THIS MEGA FUNCTION EVEN NEEDS TO BE DONE
	//LIKE IF THERE IS A UNIT OR CITY STILL IN THE SQUARE THAT CAN SEE
	if (tile[x][y].unit_number > -1 || tile[x][y].city > -1)
	{
		if (unit[tile[x][y].unit_number].GetVisionRange() < radius   ||   city[tile[x][y].city].GetVisionRange() < radius)
		{

			for (x_offset = 0; x_offset <= for_loop; x_offset++)
			{
				for (y_offset = 0; y_offset <= radius; y_offset++)
				{
					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].type = tile[x + x_offset][y + y_offset].type;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].type = tile[x + x_offset][y - y_offset].type;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].type = tile[x - x_offset][y + y_offset].type;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].type = tile[x - x_offset][y - y_offset].type;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement1 = tile[x + x_offset][y + y_offset].terrain_enhancement1;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement1 = tile[x + x_offset][y - y_offset].terrain_enhancement1;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement1 = tile[x - x_offset][y + y_offset].terrain_enhancement1;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement1 = tile[x - x_offset][y - y_offset].terrain_enhancement1;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement2 = tile[x + x_offset][y + y_offset].terrain_enhancement2;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement2 = tile[x + x_offset][y - y_offset].terrain_enhancement2;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement2 = tile[x - x_offset][y + y_offset].terrain_enhancement2;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement2 = tile[x - x_offset][y - y_offset].terrain_enhancement2;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement3 = tile[x + x_offset][y + y_offset].terrain_enhancement3;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement3 = tile[x + x_offset][y - y_offset].terrain_enhancement3;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement3 = tile[x - x_offset][y + y_offset].terrain_enhancement3;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement3 = tile[x - x_offset][y - y_offset].terrain_enhancement3;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement4 = tile[x + x_offset][y + y_offset].terrain_enhancement4;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement4 = tile[x + x_offset][y - y_offset].terrain_enhancement4;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].terrain_enhancement4 = tile[x - x_offset][y + y_offset].terrain_enhancement4;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].terrain_enhancement4 = tile[x - x_offset][y - y_offset].terrain_enhancement4;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].structure = tile[x + x_offset][y + y_offset].structure;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].structure = tile[x + x_offset][y - y_offset].structure;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].structure = tile[x - x_offset][y + y_offset].structure;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].structure = tile[x - x_offset][y - y_offset].structure;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].structure1 = tile[x + x_offset][y + y_offset].structure1;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].structure1 = tile[x + x_offset][y - y_offset].structure1;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].structure1 = tile[x - x_offset][y + y_offset].structure1;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].structure1 = tile[x - x_offset][y - y_offset].structure1;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].structure2 = tile[x + x_offset][y + y_offset].structure2;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].structure2 = tile[x + x_offset][y - y_offset].structure2;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].structure2 = tile[x - x_offset][y + y_offset].structure2;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].structure2 = tile[x - x_offset][y - y_offset].structure2;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].structure3 = tile[x + x_offset][y + y_offset].structure3;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].structure3 = tile[x + x_offset][y - y_offset].structure3;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].structure3 = tile[x - x_offset][y + y_offset].structure3;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].structure3 = tile[x - x_offset][y - y_offset].structure3;

					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].city = tile[x + x_offset][y + y_offset].city;
					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].city = tile[x + x_offset][y - y_offset].city;
					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].city = tile[x - x_offset][y + y_offset].city;
					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].city = tile[x - x_offset][y - y_offset].city;			

//					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].population = city[tile[x + x_offset][y + y_offset].city].population;
//					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].population = city[tile[x + x_offset][y - y_offset].city].population;
//					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].population = city[tile[x - x_offset][y + y_offset].city].population;
//					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].population = city[tile[x - x_offset][y - y_offset].city].population;			

//					FogOfWar[x + x_offset][y + y_offset][Game_Globals.current_player].race = city[tile[x + x_offset][y + y_offset].city].race;
//					FogOfWar[x + x_offset][y - y_offset][Game_Globals.current_player].race = city[tile[x + x_offset][y - y_offset].city].race;
//					FogOfWar[x - x_offset][y + y_offset][Game_Globals.current_player].race = city[tile[x - x_offset][y + y_offset].city].race;
//					FogOfWar[x - x_offset][y - y_offset][Game_Globals.current_player].race = city[tile[x - x_offset][y - y_offset].city].race;		
				}



				if ((x_offset % 2) == 1) //if the offset spot is odd, then there is another hex to worry about
				{
					if ((x % 2) == 1) //if the column is odd
					{
						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].type = tile[x + x_offset][y + radius + 1].type;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].type = tile[x - x_offset][y + radius + 1].type;

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement1 = tile[x + x_offset][y + radius + 1].terrain_enhancement1;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement1 = tile[x - x_offset][y + radius + 1].terrain_enhancement1;					

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement2 = tile[x + x_offset][y + radius + 1].terrain_enhancement2;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement2 = tile[x - x_offset][y + radius + 1].terrain_enhancement2;					

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement3 = tile[x + x_offset][y + radius + 1].terrain_enhancement3;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement3 = tile[x - x_offset][y + radius + 1].terrain_enhancement3;					

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement4 = tile[x + x_offset][y + radius + 1].terrain_enhancement4;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].terrain_enhancement4 = tile[x - x_offset][y + radius + 1].terrain_enhancement4;					

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].structure = tile[x + x_offset][y + radius + 1].structure;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].structure = tile[x - x_offset][y + radius + 1].structure;					

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].structure1 = tile[x + x_offset][y + radius + 1].structure1;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].structure1 = tile[x - x_offset][y + radius + 1].structure1;

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].structure2 = tile[x + x_offset][y + radius + 1].structure2;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].structure2 = tile[x - x_offset][y + radius + 1].structure2;				

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].structure3 = tile[x + x_offset][y + radius + 1].structure3;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].structure3 = tile[x - x_offset][y + radius + 1].structure3;					

						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].city = tile[x + x_offset][y + radius + 1].city;
						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].city = tile[x - x_offset][y + radius + 1].city;					

//						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].population = city[tile[x + x_offset][y + radius + 1].city].population;
//						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].population = city[tile[x - x_offset][y + radius + 1].city].population;					

//						FogOfWar[x + x_offset][y + radius + 1][Game_Globals.current_player].race = city[tile[x + x_offset][y + radius + 1].city].race;
//						FogOfWar[x - x_offset][y + radius + 1][Game_Globals.current_player].race = city[tile[x - x_offset][y + radius + 1].city].race;					
					}
					else
					{
						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].type = tile[x + x_offset][y - radius - 1].type;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].type = tile[x - x_offset][y - radius - 1].type;
					
						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement1 = tile[x + x_offset][y - radius - 1].terrain_enhancement1;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement1 = tile[x - x_offset][y - radius - 1].terrain_enhancement1;

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement2 = tile[x + x_offset][y - radius - 1].terrain_enhancement2;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement2 = tile[x - x_offset][y - radius - 1].terrain_enhancement2;					

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement3 = tile[x + x_offset][y - radius - 1].terrain_enhancement3;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement3 = tile[x - x_offset][y - radius - 1].terrain_enhancement3;					

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement4 = tile[x + x_offset][y - radius - 1].terrain_enhancement4;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].terrain_enhancement4 = tile[x - x_offset][y - radius - 1].terrain_enhancement4;					

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].structure = tile[x + x_offset][y - radius - 1].structure;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].structure = tile[x - x_offset][y - radius - 1].structure;				

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].structure1 = tile[x + x_offset][y - radius - 1].structure1;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].structure1 = tile[x - x_offset][y - radius - 1].structure1;				

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].structure2 = tile[x + x_offset][y - radius - 1].structure2;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].structure2 = tile[x - x_offset][y - radius - 1].structure2;			

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].structure3 = tile[x + x_offset][y - radius - 1].structure3;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].structure3 = tile[x - x_offset][y - radius - 1].structure3;				

						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].city = tile[x + x_offset][y - radius - 1].city;
						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].city = tile[x - x_offset][y - radius - 1].city;					

//						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].population = city[tile[x + x_offset][y - radius - 1].city].population;
//						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].population = city[tile[x - x_offset][y - radius - 1].city].population;					

//						FogOfWar[x + x_offset][y - radius - 1][Game_Globals.current_player].race = city[tile[x + x_offset][y - radius - 1].city].race;
//						FogOfWar[x - x_offset][y - radius - 1][Game_Globals.current_player].race = city[tile[x - x_offset][y - radius - 1].city].race;					
					}
				}

				if ((x_offset % 2) == 0) //if the x_offset is even, then decrease the radius by 1
					radius--;
			}
		}
	}
}
