// Fog of War.h: interface for the FOGOFWAR class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FOGOFWAR_H__2FE5D98D_76DD_491E_B5C5_06CCBBB4D4AE__INCLUDED_)
#define AFX_FOGOFWAR_H__2FE5D98D_76DD_491E_B5C5_06CCBBB4D4AE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

struct FOGOFWAR
{
	bool fog_of_war;  //is there fog of war over this tile? if yes, then you cant see the units here, and can only see the enhancements above
	bool black;			//this tile is unexplored territory

	
	//this is what this player will see on this tile, its the last time the player saw the tile
	int	type;         //terrain type of tile - grass, hill, ect... = tile[#].something
	int	terrain_enhancement1;
	int	terrain_enhancement2;
	int	terrain_enhancement3;
	int	terrain_enhancement4;
	int	structure;
	int	structure1;		//the 1,2,3 are for if we allow more then structure per tile, right now we dont
	int	structure2;
	int	structure3;

	int city; //if yes, then they see the city described by the 2 parameters below
	int	population; //city number on the tile
	int race;	
};
extern struct FOGOFWAR FogOfWar[map_width][map_height][eNUM_PLAYERS];



class FOGOFWAR_FUNCTIONS
{
public:
	void Move_To(int x, int y);
	void Move_From(int x, int y, int unit_number);
	void Begining_Turn_Update();
	void Generic(int x, int y, int range);
	void Map_Update(int x, int y, int radius);
};
extern class FOGOFWAR_FUNCTIONS	Fog_Of_War_Functions;



#endif // !defined(AFX_FOGOFWAR_H__2FE5D98D_76DD_491E_B5C5_06CCBBB4D4AE__INCLUDED_)
