//--- Specific File Includes ----//
#include "Include File.h"

void Draw_Text(const char *text, int x,int y, COLORREF color, LPDIRECTDRAWSURFACE7 lpDDS, HFONT fnt)
{
//this function draws text in 16-bit DX mode
// with the selected font

	HDC dc; // the dc
	// get the dc from surface
	lpDDS->GetDC(&dc);

	// set the colors 
	SetTextColor(dc,color);

	// set background mode to transparent
	// so black isn't copied
	SetBkMode(dc, TRANSPARENT);

	// draw the text using the font
	SelectObject(dc, fnt);
	TextOut(dc,x,y,text,strlen(text));

	// release the dc
	lpDDS->ReleaseDC(dc);

} // end Draw_Text


GUI::GUI()
{
}



void GUI::LMouseButtonDown()
{
	if (Main_Display.WindowMouseOver())		//check if the mouse is over the tile area
		Main_Display.LMouseButtonDown();	//if it is, then do its action there
}




void GUI::LMouseButtonUp()
{
	if (bWindowButtonDown)	//check ONLY if a button in the game has already been pressed
	{	
		Main_Display.LMouseButtonUp();
	}
}


void GUI::RMouseButtonDown()
{
	if (Main_Display.WindowMouseOver())  //check if the mouse is over the tile area
		Main_Display.RMouseButtonDown(); //call the window action for a mouse button down on it

}


void GUI::RMouseButtonUp()
{
	if (bWindowButtonDown)	//check ONLY if a button in the game has already been pressed
	{	
		Main_Display.RMouseButtonUp();
	}
}


void GUI::MouseDoubleClick()
{
	if (Main_Display.WindowMouseOver())  //check if the mouse is over the window
		Main_Display.MouseDoubleClick(); //call the window action for a mouse button down on it
}



void GUI::MouseOver()
{
	//check for mouse scrolling
	if (mouse_x < 5)
		cScroll.ScrollLeft();

	if (mouse_x > x_resolution - 5)
		cScroll.ScrollRight();

	if (mouse_y < 5)
		cScroll.ScrollUp();

	if (mouse_y > y_resolution - 5)
		cScroll.ScrollDown();
	
	
	
	
	if (Main_Display.WindowMouseOver())  //check if the mouse is over the window
		Main_Display.MouseOver();		//call the window action for a mouse over it
	
	else
		Main_Display.NotInMainDisplay(); //the mouse isnt in the Main Display, so dont draw the tile marker on any tile
}

