#ifndef GLOBALSTRUCTS_H
#define GLOBALSTRUCTS_H


//-------  map array and tile dimensions ------------//
#define map_width   100 //#define befor
#define map_height  100  //measured in number of tiles
// defining the number of tile types
#define NUM_TERRAIN_TYPES 3
#define KEYDOWN(buf, key) (buf[key] & 0x80)







// Struct for the tiles - each tile image has a struct
struct TERRAIN {
	LPDIRECTDRAWSURFACE7	surf;
	//terrain[tile[][].type].surf  for blitting

	BOOL					blit_flags;
	WORD					width;         //a WORD is a signed 4 digit number, like -1293 I think
	WORD					height;
};
extern struct TERRAIN terrain[NUM_TERRAIN_TYPES];




//Terrain Enhancements like roads, farms, mines, forests, solar arrays ect....
struct TERRAIN_ENHANCEMENT{
	LPDIRECTDRAWSURFACE7	surf;
};
extern struct TERRAIN_ENHANCEMENT terrain_enhancements[10];











struct STRUCTURE{  //each specific structure on the map has its own
	LPDIRECTDRAWSURFACE7	surf;    // = structures_surf[tile[][].structure#]
	// structures[tile[][].structure#].surf  for blitting

	int		GetVisionRange()   {return 2;}//return the structures vision range

	short	player_number;

	bool	goldmine;
	bool	farm;
	bool	cave;
	bool	crypt;
	//ect....

	//other things about the structure
};
extern struct STRUCTURE structure[1000];







//The Background Tile Image
struct BACKGROUND{
	int width;
	int height;
};
extern struct BACKGROUND cBackGround;



class BLINKING_SELECTED_OBJECT{
public:
	BLINKING_SELECTED_OBJECT();

	bool  bDisplay();		//TRUE if the unit/city/struct is shown, FALSE if durning the blink
	bool  bInDisplay;		//TRUE if currently being displayed
	double DisplayLength;	//Length of time in seconds that is shown
	double NonDisplayLength;//Length of time in seconds that is not shown
	double TimePassed;		//Lenght of time already passed
};
extern class BLINKING_SELECTED_OBJECT Blinking_Selected_Object;


class CURSOR{
public:
	CURSOR();

	void Cursor(int x_pos_on_screen, int y_pos_on_screen);

	short current_cursor;
	double cursor_rate;
	double TimePassed;
};
extern class CURSOR Cursor;



//the class for scrolling -- moving screen left right ect...
class SCROLL
{
public:
	SCROLL();

	void ScrollLeft();
	void ScrollRight();
	void ScrollUp();
	void ScrollDown();

	int scrolling_rate;    //number of pixels per second for scrolling
};
extern class SCROLL cScroll;






#endif


