// Include File.h: interface for the Include_File class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_INCLUDEFILE_H__61ACF12B_DB2E_4823_9C19_DE658139804A__INCLUDED_)
#define AFX_INCLUDEFILE_H__61ACF12B_DB2E_4823_9C19_DE658139804A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//////////////////////////////////////////////////////////////////////////
//---- DirectX and Windows -----//
//////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <ddraw.h>
#include <mmsystem.h>
#include <windows.h>
#include <math.h>





//////////////////////////////////////////////////////////////////////////
// #DEFINES AND STATIC VARIABLES
//////////////////////////////////////////////////////////////////////////

#include "Virtual Keys.h"  //these are the #defines for all the keyboard keys

//number of players
#define NUM_PLAYERS 2;

//-------  map array and tile dimensions ------------//
#define map_width   100 //#define befor
#define map_height  100  //measured in number of tiles

//defining the number of terrain types
#define NUM_TERRAIN_TYPES 3

//the number of tile layers
#define NUM_TILE_LAYERS 6

#define MAX_NUM_UNITS 5000 //the maximum number of similtaneous units allowed in the game

#define SafeRelease(x) if (x) { x->Release(); x=NULL;}








//////////////////////////////////////////////////////////////////////////
//ENUMS
//////////////////////////////////////////////////////////////////////////

//Movement Directions
enum {eNW_dir, eN_dir, eNE_dir, eSW_dir, eS_dir, eSE_dir};


//Unit Types
enum {eUNIT_HUMAN_SWORDSMAN = 0, eUNIT_HUMAN_CALVARY, eSETTLER, eUNIT_ELVEN_SWORDSMANE, eELVEN_CALVARY, eNUM_UNIT_TYPES};


//Races
enum {eHUMANS, eELVES};


//Player
enum {ePlayer_0, ePlayer_1, ePlayer_2, ePlayer_3, ePlayer_4, ePlayer_5, ePlayer_6, ePlayer_7, eNUM_PLAYERS};


//Terrain Types
enum {eTILE_TYPE_GRASS, eTILE_TYPE_DESERT, eTILE_TYPE_WASTE, eTILE_TYPE_SWAMP, eTILE_TYPE_MT, eTILE_TYPE_JUNGLE, eTILE_TYPE_HILL,
	  eTILE_TYPE_PRAIRE, eTILE_TYPE_SHALLOWWATER, eTILE_TYPE_DEEPWATER, eTILE_TYPE_SKY};


//Hex Outlines
enum {eHex_Outline1=0, eHex_Outline2, eHex_Outline3, eHex_Outline4, eHex_Outline5, eHex_Outline6,
	  eHex_Outline7, eHex_Outline8, eHex_Outline9, eHex_Outline10, eHex_Outline11, eHex_Outline12,
	  NUM_TILE_OUTLINES};


//Build City Methods
enum {eCantBuild, eBuildCity, eBuildCitySpell, eBuildUnderGroundCity, eBuildMtCity, eBuildSwampCity, eBuildWaterCity, eBuildWastelandCity, 
	  eBuildAnyTerrainCity, eBuildSkyCity, eBuildAnyTerrainCitySpell};








//////////////////////////////////////////////////////////////////////////
//---- Global Variables - EXTERN version ---//
//////////////////////////////////////////////////////////////////////////

//-------- monitor resolution -----------//
extern int x_resolution;
extern int y_resolution;
extern int color_depth;

//-------  map array and tile dimensions ------------//
//extern int map[map_width][map_height];  //map array

extern int tile_width;  //this is not the full width of the image, because in the horizontal, the images overlap
extern int tile_height;  //measured in pixels
extern int tile_image_width; //the tile image's dimensions
extern int tile_image_height ;

//------- Map Variables --------------//
extern int map_width_p; //map width in pixels
extern int map_height_p;
extern int x_tiles_on_screen; //number of tiles across the screen
extern int y_tiles_on_screen; 

//------- Main Window Display -------//
extern int x_start_pixel_pt;
extern int y_start_pixel_pt;
extern int x_end_pixel_pt;
extern int y_end_pixel_pt;
extern int x_max_end_pixel_pt;
extern int y_max_end_pixel_pt;
extern int x_pixels_across;
extern int y_pixels_across;

//-------- Image on Screen Variables -------------//
extern int x_screen_pos;  //this is the upper left most tile that is displayed on the screen
extern int y_screen_pos;
extern int x_tile_unit_in; //this is the tile that the selected unit is in
extern int y_tile_unit_in;




extern HFONT fnt;


extern float DeltaTime;
             

extern HWND hWnd;


//------ Storage for Color Key Value ------//
extern DWORD KeyColor;


//------ Error Return String ------//
extern const char *ErrStr;	

//------ Error Messages -----------//
extern const char Err_Reg_Class[];
extern const char Err_Create_Win[];
extern const char Err_DirectDrawCreate[];
extern const char Err_Query[];
extern const char Err_Coop[];
extern const char Err_CreateSurf[];
extern const char Err_LoadBMP[];
extern const char Err_DispMode[];
extern const char Err_LoadImage[];
extern const char Err_LoadImageCity[];

extern const char Err_RestoreProgram[];



extern RECT rct;          //source rectangle of blit

//---------- global interface pointers ----------//
extern LPDIRECTDRAW7 lpDD;
extern LPDIRECTDRAWSURFACE7 lpDDSPrimary;
extern LPDIRECTDRAWSURFACE7 lpDDSBack;

//-------- directdraw surfaces for object storage ---------//
extern LPDIRECTDRAWSURFACE7 Background_surf;

extern LPDIRECTDRAWSURFACE7 MainDisplay_TL_Corner_surf;
extern LPDIRECTDRAWSURFACE7 MainDisplay_TR_Corner_surf;
extern LPDIRECTDRAWSURFACE7 MainDisplay_BL_Corner_surf;
extern LPDIRECTDRAWSURFACE7 MainDisplay_BR_Corner_surf;
extern LPDIRECTDRAWSURFACE7 L_R_bar_surf;
extern LPDIRECTDRAWSURFACE7 T_B_bar_surf;

extern LPDIRECTDRAWSURFACE7 terrains_surf[3]; //the tile pics
extern LPDIRECTDRAWSURFACE7 blanktile_surf;
extern LPDIRECTDRAWSURFACE7 UnexploredTile_surf;
extern LPDIRECTDRAWSURFACE7 FogOfWar_surf;


extern LPDIRECTDRAWSURFACE7 Cursor1_surf;
extern LPDIRECTDRAWSURFACE7 Cursor2_surf;
extern LPDIRECTDRAWSURFACE7 Cursor3_surf;
extern LPDIRECTDRAWSURFACE7 Cursor4_surf;
extern LPDIRECTDRAWSURFACE7 Cursor5_surf;
extern LPDIRECTDRAWSURFACE7 Cursor6_surf;
extern LPDIRECTDRAWSURFACE7 Cursor7_surf;
extern LPDIRECTDRAWSURFACE7 Cursor8_surf;




extern int mouse_x;
extern int mouse_y;
extern int mouse_x_difference;
extern int mouse_y_difference;












//////////////////////////////////////////////////////////////////////////
//------ Function Prototypes -------------//
//////////////////////////////////////////////////////////////////////////

int  IsThereCombatOrMovement(int new_x_pos, int new_y_pos);
void CombatResults(int new_x_pos, int new_y_pos);
void MoveKeyPressed(int direction);
void MoveUnit(int new_x_pos, int new_y_pos);
void MapGen();
void MapVariables();
void UnitGen();

void MainGameCleanup();

void DirectInput();

void DrawTerrainEnhancements(int x_pos_on_screen, int y_pos_on_screen, int i, int j);
void DrawCitiesStructures(int x_pos_on_screen, int y_pos_on_screen, int i, int j);
void DrawUnits(int x_pos_on_screen, int y_pos_on_screen, int i, int j);

void StatsDiplay();

void EndStrategicTurn();
void NextPlayer(int current_player);
void NextRound();

void SelectNextUnit();
void CenterOnUnit();

BOOL load_sounds();
BOOL RestoreDSBuffers();
void PlayUnitAttackSound(int unit_type);
void PlayUnitMissSound(int unit_type);

bool RestoreProgram(); //function to restore the surfaces after alt-tabing out of the program
BOOL load_images();

LPDIRECTDRAWSURFACE7 bitmap_surface(LPCTSTR file_name, RECT *dims=NULL);

LRESULT CALLBACK WindowProc (HWND hWnd, unsigned uMsg, WPARAM wParam, LPARAM lParam);

bool Load_Tile_Outline_Images();
void DrawTileOutlines(int x_pos_on_screen, int y_pos_on_screen, int x, int y);

void Draw_Text(const char *text, int x,int y, COLORREF color, LPDIRECTDRAWSURFACE7 lpDDS, HFONT fnt);


//////////////////////////////////////////////////////////////////////////
//-------- Game Header Files ---------//
//////////////////////////////////////////////////////////////////////////

#include "Global Classes.h"

#include "GAME_GLOBALS.h"
#include "Main Display.h"
#include "GUI.h"
#include "Units.h"
#include "UNIT_VARIABLES.h"
#include "CITY_VARIABLES.h"
#include "STRUCTURE_VARIABLES.h"
#include "Combat.h"
#include "Tile.h"
#include "City.h"
#include "Render Frame.h"
#include "Fog of War.h"


#endif // !defined(AFX_INCLUDEFILE_H__61ACF12B_DB2E_4823_9C19_DE658139804A__INCLUDED_)
