//--- Specific File Includes ----//
#include "Include File.h"


//--------- Generate Random Map --------------//
void MapGen()
{
	srand (timeGetTime());   //the seed for random numbers so each time
							// you run the program, you get different random numbers
	for (int a=0; a < map_width; a++)
	{
		for (int b=0; b < map_height; b++)
		{
			tile[a][b].Hex_Outline	= 12;
		}
	}


	for (int i=0; i < map_width; i++)
	{
		for (int j=0; j < map_height; j++)
		{
			tile[i][j].type = rand () % 3;

			//set everything to 0.0 and FALSE and move_rate to 1.0
			tile[i][j].food					= 0.0;
			tile[i][j].minerals				= 0.0;
			tile[i][j].trade				= 0.0;
			tile[i][j].move_rate			= 1.0;
			tile[i][j].unit_number			= -1;  //-1 for no unit there
			tile[i][j].terrain_enhancement1 = -1;
			tile[i][j].structure			= -1;
			tile[i][j].structure1			= -1;
			tile[i][j].bMouse_In			= FALSE;
			tile[i][j].city					= -1;


			//set the map black and turn on fog of war
			for (int k = 0; k < eNUM_PLAYERS; k++)
			{
				FogOfWar[i][j][k].black					= TRUE;//is there fog of war over this tile? if yes, then you cant see the units here, and can only see the enhancements above
				FogOfWar[i][j][k].fog_of_war			= TRUE;//this tile is unexplored territory

				//this is what this player will see on this tile, its the last time the player saw the tile
				FogOfWar[i][j][k].type					= tile[i][j].type; //terrain type of tile - grass, hill, ect... = tile[#].something
				FogOfWar[i][j][k].terrain_enhancement1	= -1;
				FogOfWar[i][j][k].terrain_enhancement2	= -1;
				FogOfWar[i][j][k].terrain_enhancement3	= -1;
				FogOfWar[i][j][k].terrain_enhancement4	= -1;
				FogOfWar[i][j][k].structure				= -1;
				FogOfWar[i][j][k].structure1			= -1; //the 1,2,3 are for if we allow more then structure per tile, right now we dont
				FogOfWar[i][j][k].structure2			= -1;
				FogOfWar[i][j][k].structure3			= -1;

				FogOfWar[i][j][k].city					= -1; //if yes, then they see the city described by the 2 parameters below
				FogOfWar[i][j][k].population			= -1; //city number on the tile
				FogOfWar[i][j][k].race					= -1;
			}
		}
	}

		
	//initialize each tile
	for (int k=0; k < map_width; k++)
	{
		for (int l=0; l < map_height; l++)
		{
			if (tile[k][l].type == 0)
			{	//then it is grassland
				tile[k][l].food	= 2.0;
			}
			//THESE TYPE NUMBERS ARE WRONG

			if (tile[k][l].type == 1)
			{	//then it is desert
				tile[k][l].minerals = 1.0;
			}

			if (tile[k][l].type == 2)
			{	//then it is wasteland
				tile[k][l].move_rate = 2.0;
			}
		}
	}
}





