//--- Specific File Includes ----//
#include "Include File.h"


void MoveUnit(int new_x_pos, int new_y_pos)
{
	//you can only move the unit if the unit belongs to the current player
	if (unit[Unit_Vars.selected_unit].player_number == Game_Globals.current_player)
	{
		int prev_x_pos = unit[Unit_Vars.selected_unit].x_tile;
		int prev_y_pos = unit[Unit_Vars.selected_unit].y_tile;
		int CorM;

	//	first check if the unit can move, if it has enough movement pts
	//	then check if it can move into that hex if its wall
	//	then if it can move into a valid hex, check if there is combat or a
	//	friendly unit there, if not then, move the unit
	//	if there is combat, then do combat and remove all remainig movement pts


		//a unit can only move 1 hex at a time
		if ((new_x_pos - prev_x_pos) <= 1 && (new_x_pos - prev_x_pos) >= -1 && (new_y_pos - prev_y_pos) <= 1 && (new_y_pos - prev_y_pos) >= -1)
		{

			//check if the unit has enough movment points remaining
			if (unit[Unit_Vars.selected_unit].movement == 0)
				return;
			
			//check if trying to walk off edge of map
			if (new_x_pos < 0  ||  new_y_pos < 0  ||  new_x_pos > 99  ||  new_y_pos > 99)
				//then the unit can not move, so return
				return;


			//if there is combat, then you dont move the unit
			CorM = IsThereCombatOrMovement(new_x_pos, new_y_pos);

			if(CorM == 2) //CorM_Combat)  //then enemy unit so combat results
			{
				CombatResults(new_x_pos, new_y_pos);
				unit[Unit_Vars.selected_unit].movement = 0;
				SelectNextUnit(); //select the next unit
				return;
			}
			else if (CorM == 1) //CorM_Friendly) //then cant move there
				return;
			else	//move the unit now
			{	
				//the previous spot no longer has a unit there
				tile[prev_x_pos][prev_y_pos].unit_number = -1;


				//Now Move The Unit
				unit[Unit_Vars.selected_unit].x_tile = new_x_pos;
				unit[Unit_Vars.selected_unit].y_tile = new_y_pos;

				//tell the tile the unit moves onto that there is a unit there
				tile[new_x_pos][new_y_pos].unit_number = Unit_Vars.selected_unit;

		//******** put in terrain calculations on movement pt reduction in here
				//reduce remaining movement points
				unit[Unit_Vars.selected_unit].movement--;


		//******* FOG OF WAR *******//
				Fog_Of_War_Functions.Move_From(prev_x_pos, prev_y_pos, Unit_Vars.selected_unit);   //turn on the fog of war where the unit was previously
				Fog_Of_War_Functions.Move_To(new_x_pos, new_y_pos);    //turn off fog of war at units new position
													   //the 0 is for a unit being moved, or an in turn update of already explored area

			}
		}
	}
	else
	{
		//you cant move the unit, so play a sound here saying "this is not your unit"
	}
}
