//--- Specific File Includes ----//
#include "Include File.h"


//------------- function to draw a frame -------------//
void RENDER_FRAME::Render()
{
/////////////////////////////////////////////////////////////////////////////////////////////////////
//Draw the back ground absolutely first
	Background();
/////////////////////////////////////////////////////////////////////////////////////////////////////

	//After drawing the back ground, render each window in order from the back most to the
	//front most

	Main_Display.Render();

	
	// UNIT STATS DISPLAY
	StatsDiplay();



	//flip to the primary surface
	lpDDSPrimary->Flip (NULL, DDFLIP_WAIT);
}






void RENDER_FRAME::Background()
{
	int x_pos_on_screen;  //final spot on the monitor
	int y_pos_on_screen;

	rct.left	= 0;
	rct.top		= 0;
	
	//get the number of images needed to tile across the screen
	int x_num_across = x_resolution / cBackGround.width;
	if (x_num_across * cBackGround.width != x_resolution)
		x_num_across++;

	int y_num_across = y_resolution / cBackGround.height;
	if (y_num_across * cBackGround.height != y_resolution)
		y_num_across++;


	for (int x = 0; x < x_num_across; x++)
	{
		
		
		//new position on the screen
		x_pos_on_screen = x * cBackGround.width;

		//the tile will be cut off if its the one on the end, so clip it
		if(x == x_num_across -1)
			rct.right = x_resolution - x_pos_on_screen;
		else
			rct.right	= cBackGround.width;

		
		for (int y = 0; y < y_num_across; y++)
		{
			

			//new position on the screen
			y_pos_on_screen = y * cBackGround.height;

			//the tile will be cut off if its the the one on the end, so clip it
			if(y == y_num_across -1)
				rct.bottom = y_resolution - y_pos_on_screen;
			else
				rct.bottom	= cBackGround.height;


			//and then blit the tile to the screen
			lpDDSBack->BltFast (x_pos_on_screen, y_pos_on_screen, Background_surf, &rct, DDBLTFAST_WAIT);
		}
	}
}


BLINKING_SELECTED_OBJECT::BLINKING_SELECTED_OBJECT()
{
	bInDisplay = TRUE;
	TimePassed = 0.0;
	DisplayLength = 0.5;
	NonDisplayLength = 0.25;
}

bool BLINKING_SELECTED_OBJECT::bDisplay()
{
	TimePassed += DeltaTime;

	if(bInDisplay) //if the object is currently being displayed, then check if it still should be
	{
		if (TimePassed > DisplayLength) //if greater then, then its no longer to be displayed
		{
			TimePassed = 0; //reset this for the switch over
			bInDisplay = FALSE;
			return FALSE;
		}
		else
			return TRUE;  //then it still should still be displayed
	}
	else //if the object is currently NOT being displayed, then if it still shouldnt be
	{
		if (TimePassed > NonDisplayLength) //if greater then, then is should now be displayed
		{
			TimePassed = 0; //reset this for the switch over
			bInDisplay = TRUE;
			return TRUE;
		}
		else
			return FALSE; //then it still shouldnt be displayed
	}
}





CURSOR::CURSOR()
{
	TimePassed = 0.0;
	current_cursor = 1;
	cursor_rate = 0.05;
}
void CURSOR::Cursor(int x_pos_on_screen, int y_pos_on_screen)
{
	TimePassed += DeltaTime;  //get the time passed

	if (TimePassed > cursor_rate) //if greater then, then switch to the next cursor
	{
		current_cursor++;
		TimePassed = 0.0;
	}

	if (current_cursor == 9)  //loop back around to the first cursor
		current_cursor = 1;

	switch (current_cursor)
	{                      //now draw the cursor
	case 1:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor1_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 2:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor2_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 3:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor3_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 4:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor4_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 5:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor5_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 6:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor6_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 7:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor7_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	case 8:
		lpDDSBack->BltFast(x_pos_on_screen, y_pos_on_screen, Cursor8_surf, &rct, DDBLTFAST_WAIT | DDBLTFAST_SRCCOLORKEY);
		break;
	default:
		break;
	}
}

