// Tile.h: interface for the TILE class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TILE_H__0759C6A2_3518_4377_B8B5_AD7696680FEF__INCLUDED_)
#define AFX_TILE_H__0759C6A2_3518_4377_B8B5_AD7696680FEF__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//--------- A STRUCT FOR EACH AND EVERY TILE IN THE GAME ----------//
struct TILE{
	int		type;         //terrain type of tile - grass, hill, ect... = tile[#].something
	int		terrain_enhancement1;
	int		terrain_enhancement2;
	int		terrain_enhancement3;
	int		terrain_enhancement4;
	int		city; //city number on the tile
	int		structure;
	int		structure1;		//the 1,2,3 are for if we allow more then structure per tile, right now we dont
	int		structure2;
	int		structure3;
	
	int		unit_number;//the unit number of the unit that is on this tile? -1 if no unit
	int		unit1; 
	int		unit2; //eventually take
	int		unit3;
	int		unit4;
	int		unit5;
	int		unit6;
	int		unit7;
	int		unit8;
	int		unit9;

//upto this point, the previous things in this struct are in
//order in which they are to be blitted to the surface
//first, the terrain is blitted, then if there is farm, that would be
//terrain_enhancement1 and that would be blitted
//if there is a road, that would be terrain_enhancement2 and drawn next
//the city if there is one is drawn next
//and then the strongest unit is drawn, and which is unit1

	float	food;         //amount of food tile can currently produce
	float	minerals;     //amount of minerals tile can currently produce
	float	trade;
	float	move_rate;    //the move rate factor = .3333 if roads,  = 2.0 if hills ect...


	//does the tile have any outlines from a city on it? if it does, it will be = to 0 - 11, and = 12 if not
	short Hex_Outline;

	//is the mouse over this hex?
	bool bMouse_In;

};  //location of the tile on the map
extern struct TILE tile[map_width][map_height];


#endif // !defined(AFX_TILE_H__0759C6A2_3518_4377_B8B5_AD7696680FEF__INCLUDED_)
