// UNIT_VARIABLES.cpp: implementation of the UNIT_VARIABLES class.
//
//////////////////////////////////////////////////////////////////////

#include "Include File.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

UNIT_VARIABLES::UNIT_VARIABLES()
{
	selected_unit = -1;
	unit_image_width  = 48;
	unit_image_height = 52;
}

UNIT_VARIABLES::~UNIT_VARIABLES()
{
	SafeRelease (unitImages_surf[0]);
	SafeRelease (unitImages_surf[1]);
	SafeRelease (unitImages_surf[2]);

	SafeRelease (hpbars_surf[0]);
	SafeRelease (hpbars_surf[1]);
	SafeRelease (hpbars_surf[2]);
	SafeRelease (hpbars_surf[3]);
	SafeRelease (hpbars_surf[4]);
	SafeRelease (hpbars_surf[5]);
	SafeRelease (hpbars_surf[6]);
	SafeRelease (hpbars_surf[7]);
	SafeRelease (hpbars_surf[8]);
	SafeRelease (hpbars_surf[9]);
	SafeRelease (hpbars_surf[10]);
	SafeRelease (playerhpbars_surf[0]);
	SafeRelease (playerhpbars_surf[1]);

}

void UNIT_VARIABLES::Load_Images()
{
	//unit type 0 unit (swordsman pic)
	unitImages_surf[0] = bitmap_surface("unitImage0.bmp");
	if (!unitImages_surf[0])
	{
		ErrStr=Err_LoadImage;
	}

	//unit type 1 (calvary pic)
	unitImages_surf[1] = bitmap_surface("unitImage1.bmp");
	if (!unitImages_surf[1])
	{
		ErrStr=Err_LoadImage;
	}

	//unit type 2 (settler pic)
	unitImages_surf[2] = bitmap_surface("unitImage2.bmp");
	if (!unitImages_surf[2])
	{
		ErrStr=Err_LoadImage;
	}

	

//********* Load the hp Power Bar Pics ***********************************
	hpbars_surf[10] = bitmap_surface("hp100%.bmp");
	if (!hpbars_surf[10])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[9] = bitmap_surface("hp90%.bmp");
	if (!hpbars_surf[9])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[8] = bitmap_surface("hp80%.bmp");
	if (!hpbars_surf[8])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[7] = bitmap_surface("hp70%.bmp");
	if (!hpbars_surf[7])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[6] = bitmap_surface("hp60%.bmp");
	if (!hpbars_surf[6])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[5] = bitmap_surface("hp50%.bmp");
	if (!hpbars_surf[5])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[4] = bitmap_surface("hp40%.bmp");
	if (!hpbars_surf[4])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[3] = bitmap_surface("hp30%.bmp");
	if (!hpbars_surf[3])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[2] = bitmap_surface("hp20%.bmp");
	if (!hpbars_surf[2])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[1] = bitmap_surface("hp10%.bmp");
	if (!hpbars_surf[1])
	{
		ErrStr=Err_LoadImage;
	}
	hpbars_surf[0] = bitmap_surface("hp0%.bmp",&rct);
	if (!hpbars_surf[0])
	{
		ErrStr=Err_LoadImage;
	}

//************************************************************************
	playerhpbars_surf[0] = bitmap_surface("player0hpbar.bmp",&rct);
	if (!playerhpbars_surf[0])
	{
		ErrStr=Err_LoadImage;
	}

	playerhpbars_surf[1] = bitmap_surface("player1hpbar.bmp",&rct);
	if (!playerhpbars_surf[1])
	{
		ErrStr=Err_LoadImage;
	}




//************************************************************************
	//get the pixel format
	DDPIXELFORMAT ddpf;
	ddpf.dwSize = sizeof(ddpf);
	lpDDSPrimary->GetPixelFormat (&ddpf);

	//Determine proper key for pixel format
	KeyColor = ddpf.dwGBitMask;        //the G is for pure green, which is the color that gets replaced

	//set the color key
	DDCOLORKEY key;
	key.dwColorSpaceLowValue = KeyColor;
	key.dwColorSpaceHighValue = KeyColor;
	
	unitImages_surf[0]->SetColorKey(DDCKEY_SRCBLT, &key);
	unitImages_surf[1]->SetColorKey(DDCKEY_SRCBLT, &key);
	unitImages_surf[2]->SetColorKey(DDCKEY_SRCBLT, &key);

	hpbars_surf[0]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[1]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[2]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[3]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[4]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[5]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[6]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[7]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[8]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[9]->SetColorKey(DDCKEY_SRCBLT, &key);
	hpbars_surf[10]->SetColorKey(DDCKEY_SRCBLT, &key);
	playerhpbars_surf[0]->SetColorKey(DDCKEY_SRCBLT, &key);
	playerhpbars_surf[1]->SetColorKey(DDCKEY_SRCBLT, &key);
}

