//--- Specific File Includes ----//
#include "Include File.h"

UNIT::UNIT()
{
	for (int i = 0; i < MAX_NUM_UNITS; i++) 
		unit[i].alive = FALSE;       //set every unit in the game to not existing yet
}

float UNIT::GetAttack()
{
	float attack = unit_types[unit_type].attack;

//MORAL
	if (moral == 1)//very bad
		attack -= 2;
	else if (moral == 2)//poor
		attack -= 1;
	else if (moral == 5)//very high
		attack += 1;

//EXPERIENCE
	attack += experience * 0.5;

	return attack;
}



float UNIT::GetDefense()
{
	float defense = unit_types[unit_type].defense;

//MORAL
	if (moral == 1)//very bad
		defense -= 2;
	else if (moral == 2)//poor
		defense -= 1;
	else if (moral == 5)//very high
		defense += 1;
	
//EXPERIENCE
	defense += experience * 0.5;

	return defense;
}


float UNIT::GetPower()
{
	float power = unit_types[unit_type].power;
	return power;
}

float UNIT::GetArmor()
{
	float armor = unit_types[unit_type].armor;
	return armor;
}

float UNIT::GetDamage()
{
	float damage = unit_types[unit_type].damage;

//MORAL
	if (moral == 1)//very bad
		damage -= 1;
	if (moral == 5)//very high
		damage += 1;
	
//EXPERIENCE
	damage += experience * 0.25;

	return damage;
}

short UNIT::GetNumAttacks()
{
	short num_attacks = unit_types[unit_type].num_attacks;
	//check for spells or other modifiers
	return num_attacks;
}


void UNIT::CreateUnit(int unit_type, int player_number, int x_tile, int y_tile)	 //this function is called each time a new unit is created in the game
{	// the unit_type is passed in

	int unit_number;
	int i = 0;
	bool notDone = TRUE;

	//find the first unit[unit_number].alive that is not alive
	while (notDone)
	{
		if (!unit[i].alive)
		{
			notDone = FALSE;
			unit_number = i;
		}
		i++;

		if (i == MAX_NUM_UNITS) //stop the loop if run out of free spaces, and dont create the unit
			notDone = FALSE;
	}	


	//tell the map tile there is a unit there
	tile[x_tile][y_tile].unit_number = unit_number;
	unit[unit_number].x_tile = x_tile;
	unit[unit_number].y_tile = y_tile;


	//initialize all units the same with these
	unit[unit_number].alive				= TRUE;
	unit[unit_number].unit_type			= unit_type;
	unit[unit_number].player_number		= player_number;
	unit[unit_number].experience		= 0;
	unit[unit_number].moral				= 3;


	//now set the specifics for the unit
	unit[unit_number].hp			= unit_types[unit_type].hp;
	unit[unit_number].movement		= unit_types[unit_type].movement;


	//spell affects and other effects that will be particular to this specific unit
	unit[unit_number].turn			= unit_types[unit_type].turn;		
	unit[unit_number].charge		= unit_types[unit_type].charge;
	unit[unit_number].heal			= unit_types[unit_type].heal;


	unit[unit_number].cursed		= FALSE;
	unit[unit_number].blessed		= FALSE;
	unit[unit_number].stone_skin	= FALSE;
	unit[unit_number].poisoned		= FALSE;
	unit[unit_number].frozen		= FALSE;
	unit[unit_number].burning		= FALSE;
	unit[unit_number].shocked		= FALSE;
	unit[unit_number].turned		= FALSE;
	unit[unit_number].webbed		= FALSE;
	unit[unit_number].entangled		= FALSE;
	unit[unit_number].enchanted		= FALSE;
	unit[unit_number].hasted		= FALSE;
	unit[unit_number].water_walking	= FALSE;
	unit[unit_number].invisible		= FALSE;
	unit[unit_number].wind_walking	= FALSE;
}


void UNIT::DestroyUnit(int unit_number)
{
	alive = FALSE;   //the unit is turned into a city, so its not dead
	tile[x_tile][y_tile].unit_number = -1;  //remove the unit from the tile

	//turn on the fog of war where the unit was
	Fog_Of_War_Functions.Move_From(x_tile, y_tile, unit_number);   //turn on the fog of war where the unit was previously

	//select the next unit
	SelectNextUnit();
	CenterOnUnit(); 
}



bool UNIT::CanRetaliate()
{
	if (retaliations < unit_types[unit_type].retaliations)
		return TRUE;
	else
		return FALSE;
}



bool UNIT::CanMove()
{
	if (movement > 0)
		return true;
	else
		return false;
}


int UNIT::GetVisionRange()
{
//	int VisionRange = unit_types[unit_type].vision_range;///////////////////////////////
	int VisionRange = 2;
	//Then check for other modifiers like blinded, or enhanced vision ect...
	return VisionRange;
}

bool UNIT::CanFly()
{
	if (unit_types[unit_type].can_fly)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::CanSwim()
{
	if (unit_types[unit_type].can_swim)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Calvary()
{
	if (unit_types[unit_type].calvary)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Swordsman()
{
	if (unit_types[unit_type].swordsman)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Pikeman()
{
	if (unit_types[unit_type].pikeman)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Archer()
{
	if (unit_types[unit_type].archer)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Slinger()
{
	if (unit_types[unit_type].slinger)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Catapult()
{
	if (unit_types[unit_type].catapult)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Ram()
{
	if (unit_types[unit_type].ram)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Dragon()
{
	if (unit_types[unit_type].dragon)
		return TRUE;
	else
		return FALSE;
}

//UNIT SPECIAL ABILITIES
bool UNIT::Cold_Breath()
{
	if (unit_types[unit_type].cold_breath)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Fire_Breath()
{
	if (unit_types[unit_type].fire_breath)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Dominate()
{
	if (unit_types[unit_type].dominate)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Heal()
{
	if (unit_types[unit_type].heal)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Web()
{
	if (unit_types[unit_type].web)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Fire_Touch()
{
	if (unit_types[unit_type].fire_touch)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Entangle()
{
	if (unit_types[unit_type].entangle)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Turn()
{
	if (unit_types[unit_type].turn)
		return TRUE;
	else
		return FALSE;
}

bool UNIT::Magic()
{
	if (unit_types[unit_type].magic)
		return TRUE;
	else
		return FALSE;
}
//ect....