//--- Specific File Includes ----//
#include "Include File.h"


//-------- windows message handler --------------//
LRESULT CALLBACK
WindowProc (HWND hWnd, unsigned uMsg, WPARAM wParam, LPARAM lParam)
{
	int previous_mouse_x;  //saves the previous mouse position to get the difference
	int previous_mouse_y;


	switch (uMsg)
	{
	case WM_DESTROY:      //handles events like ALT-F4 being pressed to close the app
		MainGameCleanup();
		Game_Globals.bMainNotDone = FALSE;
		PostQuitMessage(0);
		break;

	//get the mouse coordinates
	case WM_MOUSEMOVE:
		previous_mouse_x = mouse_x;
		previous_mouse_y = mouse_y;
		mouse_x = LOWORD(lParam);//x is contained in the lower 16 bits
		mouse_y = HIWORD(lParam);//y is contained in the upper 16 bits
		mouse_x_difference = mouse_x - previous_mouse_x;
		mouse_y_difference = mouse_y - previous_mouse_y;
		break;

	//the mouse buttons
	case WM_LBUTTONDOWN:
		GUI.bLMouseButtonDown = TRUE;
		GUI.LMouseButtonDown();
		break;
	case WM_LBUTTONUP:
		GUI.bLMouseButtonDown = FALSE;
		GUI.LMouseButtonUp();
		break;

	case WM_RBUTTONDOWN:
		GUI.bRMouseButtonDown = TRUE;
		GUI.RMouseButtonDown();
		break;
	case WM_RBUTTONUP:
		GUI.bRMouseButtonDown = FALSE;
		GUI.RMouseButtonUp();
		break;

	case WM_LBUTTONDBLCLK:
		GUI.MouseDoubleClick();
		break;


	//the keyboard keys
	case WM_KEYDOWN:
		switch (wParam)
		{
		case VK_ESCAPE:		//exits the game
			MainGameCleanup();
			Game_Globals.bMainNotDone = FALSE;
			PostQuitMessage(0);
			break;



		case 'c': case 'C':
			CenterOnUnit();		//centers on the selected unit
			break;

		case 'e': case 'E':	
			EndStrategicTurn();	//ends the turn and flips to the other player
			break;

		case VK_SPACE:
			SelectNextUnit();	//selects the next unit belonging to the current player
			CenterOnUnit();		//and centers on it
			break;

		case VK_G:	//Toggles the city tile outlines on or off
			if(Game_Globals.bDraw_Tile_Outline)
				Game_Globals.bDraw_Tile_Outline = FALSE;
			else
				Game_Globals.bDraw_Tile_Outline = TRUE;
			break;

		case VK_B:
			city[0].BuildCity(eBuildCity); //the build city method
			break;
                		


	//********** These Keys Control the Currently Selected Unit for Movement******************
	//********** INSERT **********************************************************************
		case VK_INSERT:
			//Insert is the NW direction		
			MoveKeyPressed(eNW_dir);
			break;

	//********** HOME ***********************************************************************
		case VK_HOME:
			//Home is the N direction		
			MoveKeyPressed(eN_dir);
			break;

	//********** PAGE UP *********************************************************************  
		case VK_PRIOR:  //page up
			//Page Up is the NE direction		
			MoveKeyPressed(eNE_dir);
			break;

	//********** DELETE **********************************************************************
		case VK_DELETE:
			//Delete is the SW direction		
			MoveKeyPressed(eSW_dir);
			break;
		
	//********** END ************************************************************************
		case VK_END:
			//End is the S direction		
			MoveKeyPressed(eS_dir);
			break;

	//********** PAGE DOWN********************************************************************
		case VK_NEXT:  //page down
			//Page Down is the SE direction		
			MoveKeyPressed(eSE_dir);
			break;


		default:
			break;
		}
		break;


	default:
		return DefWindowProc (hWnd, uMsg, wParam, lParam);

	}
	return 0L;
}
