//--- Specific File Includes ----//

#include "stdafx.h"
#include "Include File.h"




/******************************************************************
INITIAL DECLARATION OF GLOBAL variables
/******************************************************************/

//-------- monitor resolution -----------//
int x_resolution=1280;
int y_resolution=1024;
int color_depth =16;
int map[map_width][map_height];  //map array
int tile_width  = 33;  //this is not the full width of the image, because in the horizontal, the images overlap
int tile_height = 32;  //measured in pixels
int tile_image_width  = 48; //the tile image's dimensions
int tile_image_height = 52;
//------- Map Variables --------------//
int map_width_p  = map_width  * tile_width;  //map width in pixels
int map_height_p = map_height * tile_height;
int x_tiles_on_screen = 17; //number of tiles across the screen
int y_tiles_on_screen = 18;
//------- Main Window Display -------//
int x_start_pixel_pt;
int y_start_pixel_pt;
int x_end_pixel_pt;
int y_end_pixel_pt;
int x_max_end_pixel_pt;
int y_max_end_pixel_pt;
int x_pixels_across;
int y_pixels_across;
//-------- Image on Screen Variables -------------//
int x_screen_pos;  //this is the upper left most tile that is displayed on the screen
int y_screen_pos;
int x_tile_unit_in; //this is the tile that the selected unit is in
int y_tile_unit_in;
//------- Other Globals --------------//
HFONT fnt = CreateFont(0,0,0,0,0,0,0,0,0,0,0,0,0, "Courier New");






float DeltaTime;
//------ window class information -------//
static char szClass[] = "RTSClass";
static char szCaption[] = "Example - RTS";
//------ Error Return String ------//
const char *ErrStr=NULL;	
//------ Error Messages ------//
const char Err_Reg_Class[]			= "Error Registering Window Class";
const char Err_Create_Win[]			= "Error Creating Window";
const char Err_DirectDrawCreate[]	= "DirectDrawCreate FAILED";
const char Err_NoRestoreResolution[]= "Could not restore the original Windows resolution";
const char Err_Query[]				= "QueryInterface FAILED";
const char Err_Coop[]				= "SetCooperativeLevel FAILED";
const char Err_CreateBackSurf[]		= "CreateBackSurface FAILED";
const char Err_CreatePrimarySurf[]	= "CreatePrimarySurface FAILED";
const char Err_CreateStoredPrimarySurf[]	= "CreateStoredPrimarySurface FAILED";
const char Err_CreateStoredBackSurf[]= "CreateStoredBackSurface FAILED";
const char Err_LoadBMP[]			= "Error Loading Image";
const char Err_DispMode[]			= "Error Setting Display Mode";
const char Err_LoadImage[]			= "Error Loading Image";
const char Err_LoadImageCity[]		= "Error Loading City Image";
const char Err_LoadImageInterface[]	= "Error Loading Image Interface";
const char Err_LoadImageBackGround[]= "Error Loading Image Back_Ground";
const char Err_RestoreProgram[]		= "Unable to reload images after alt-tab";
//for direct input
const char Err_DirectInputCreate[]  = "DirectInputCreate FAILED";
const char Err_CreateKeyboard[]     = "CreateDevice Keyboard FAILED";
const char Err_CreateMouse[]		= "CreateDevice Mouse FAILED";
//for direct sound
const char Err_DirectSoundCreate[]  = "DirectSoundCreate FAILED";
const char Err_CreateBuff[]         = "CreateBuffer FAILED";
const char Err_LoadWAV[]			= "Error Loading Sound";

RECT rct;          //source rectangle of blit
//---------- global interface pointers ----------//
LPDIRECTDRAW7		 lpDD=NULL;
LPDIRECTDRAWSURFACE7 lpDDSPrimary=NULL;
LPDIRECTDRAWSURFACE7 lpDDSBack=NULL;
//-------- directdraw surfaces for object storage ---------//
LPDIRECTDRAWSURFACE7 Background_surf=NULL;

LPDIRECTDRAWSURFACE7 MainDisplay_TL_Corner_surf=NULL;
LPDIRECTDRAWSURFACE7 MainDisplay_TR_Corner_surf=NULL;
LPDIRECTDRAWSURFACE7 MainDisplay_BL_Corner_surf=NULL;
LPDIRECTDRAWSURFACE7 MainDisplay_BR_Corner_surf=NULL;
LPDIRECTDRAWSURFACE7 L_R_bar_surf=NULL;
LPDIRECTDRAWSURFACE7 T_B_bar_surf=NULL;

LPDIRECTDRAWSURFACE7 terrains_surf[3]={NULL,NULL,NULL}; //the tile pics
LPDIRECTDRAWSURFACE7 blanktile_surf=NULL;
LPDIRECTDRAWSURFACE7 UnexploredTile_surf=NULL;
LPDIRECTDRAWSURFACE7 FogOfWar_surf=NULL;


LPDIRECTDRAWSURFACE7 Cursor1_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor2_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor3_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor4_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor5_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor6_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor7_surf=NULL;
LPDIRECTDRAWSURFACE7 Cursor8_surf=NULL;



HWND hWnd;
//------ Storage for Color Key Value ------//
DWORD KeyColor;


int mouse_x;
int mouse_y;
int mouse_x_difference;
int mouse_y_difference;


/******************************************************************/
//INITIAL structs DECLARATION
/******************************************************************/
TILE tile[map_width][map_height];
TERRAIN terrain[NUM_TERRAIN_TYPES];
TERRAIN_ENHANCEMENT terrain_enhancements[10];
CITY city[1000];
STRUCTURE structure[1000];


UNIT unit[MAX_NUM_UNITS];
UNIT_TYPES unit_types[5];
BACKGROUND cBackGround;
RENDER_FRAME cRender_Frame;
SCROLL cScroll;
COMBAT Combat;
BLINKING_SELECTED_OBJECT Blinking_Selected_Object;
CURSOR Cursor;
FOGOFWAR FogOfWar[map_width][map_height][eNUM_PLAYERS];
FOGOFWAR_FUNCTIONS Fog_Of_War_Functions;


class GUI GUI;
MAIN_DISPLAY Main_Display;
GAME_GLOBALS Game_Globals;
UNIT_VARIABLES Unit_Vars;
CITY_VARIABLES City_Vars;
STRUCTURE_VARIABLES Structure_Vars;







//------ Function to Load a Bitmap into a DirectDraw Surface ------//
LPDIRECTDRAWSURFACE7 bitmap_surface(LPCTSTR file_name, RECT *dims)
{
	HDC hdc;
	HBITMAP bit;
	LPDIRECTDRAWSURFACE7 surf;


	//load the interface bitmap
	bit = (HBITMAP) LoadImage (NULL, file_name, IMAGE_BITMAP, 0, 0,
									LR_DEFAULTSIZE|LR_LOADFROMFILE);
	
	if (!bit)
		return NULL;   //failed to load, return failure to caller



	// getting the bitmap dimensions
	BITMAP bitmap;
	GetObject (bit, sizeof(BITMAP), &bitmap);
	int surf_width = bitmap.bmWidth;
	int surf_height = bitmap.bmHeight;



	// create the surface
	HRESULT ddrval;
	DDSURFACEDESC2 ddsd;
	ZeroMemory (&ddsd, sizeof(ddsd));
	ddsd.dwSize = sizeof(DDSURFACEDESC2);
	ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT ;
	ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
	ddsd.dwWidth = surf_width;
	ddsd.dwHeight = surf_height;



	// attempt to create the surface
	ddrval = lpDD->CreateSurface (&ddsd, &surf, NULL);



	// created ok?
	if (ddrval != DD_OK)
	{
		DeleteObject (bit);   // if not created, release the bitmap and return
		return NULL;         //  failure to caller
	}
	else
	{
		surf->GetDC (&hdc);  //if created, get a DC for the surface



		// generate a compatible DC
		HDC bit_dc = CreateCompatibleDC (hdc);
 


		// blit the interface to the surface
		SelectObject (bit_dc, bit);
		BitBlt (hdc, 0, 0, surf_width, surf_height, bit_dc, 0, 0, SRCCOPY);




		// releasing the DCs
		surf->ReleaseDC (hdc);
		DeleteDC (bit_dc);



		// save the dimensions if rectangle pointer provided
		if (dims)
		{
			dims->left=0;
			dims->top=0;
			dims->right=surf_width;
			dims->bottom=surf_height;
		}
	}

	// clear the bitmap
	DeleteObject (bit);


	//return pointer to caller
	return surf;
}







//--------- cleanup function to release objects --------------//
void MainGameCleanup()
{
	//release loaded image surfaces
	SafeRelease (Background_surf);

	SafeRelease (MainDisplay_TL_Corner_surf);
	SafeRelease (MainDisplay_TR_Corner_surf);
	SafeRelease (MainDisplay_BL_Corner_surf);
	SafeRelease (MainDisplay_BR_Corner_surf);
	SafeRelease (L_R_bar_surf);
	SafeRelease (T_B_bar_surf);

	SafeRelease (terrains_surf[0]);
	SafeRelease (terrains_surf[1]);
	SafeRelease (terrains_surf[2]);

	SafeRelease (blanktile_surf);
	SafeRelease (UnexploredTile_surf);
	SafeRelease (FogOfWar_surf);






	
	SafeRelease (Cursor1_surf);
	SafeRelease (Cursor2_surf);
	SafeRelease (Cursor3_surf);
	SafeRelease (Cursor4_surf);
	SafeRelease (Cursor5_surf);
	SafeRelease (Cursor6_surf);
	SafeRelease (Cursor7_surf);
	SafeRelease (Cursor8_surf);

	



	// release DirectDraw interfaces
	SafeRelease (lpDDSPrimary);
	SafeRelease (lpDD);



	// display error if one thrown
	if (ErrStr)
	{
		MessageBox (NULL, ErrStr, szCaption, MB_OK);
		ErrStr=NULL;
	}
}




















//---------- function to load object images and set up layers -------//
BOOL load_images()
{

	Unit_Vars.Load_Images();
	City_Vars.Load_Images();
	Structure_Vars.Load_Images();



//---------------------------------------------------------------------------------------------//
	//load the background image
	Background_surf = bitmap_surface("background.bmp", &rct);
	if(!Background_surf)
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}
	cBackGround.width  = rct.right;     //get the background image size, so people can edit it, and it
	cBackGround.height = rct.bottom;		//will still tile

//**********************************************************************************************************
	//Main Display Top Left Corner
	MainDisplay_TL_Corner_surf = bitmap_surface("MainDisplay TL Corner.bmp");
	if(!MainDisplay_TL_Corner_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}
	//Main Display Top Right Corner
	MainDisplay_TR_Corner_surf = bitmap_surface("MainDisplay TR Corner.bmp");
	if(!MainDisplay_TR_Corner_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}
	//Main Display Bottom Left Corner
	MainDisplay_BL_Corner_surf = bitmap_surface("MainDisplay BL Corner.bmp");
	if(!MainDisplay_BL_Corner_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}
	//Main Display Bottom Right Corner
	MainDisplay_BR_Corner_surf = bitmap_surface("MainDisplay BR Corner.bmp");
	if(!MainDisplay_BR_Corner_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}
	//Main Display Left and Right bars
	L_R_bar_surf = bitmap_surface("l & r bar.bmp");
	if(!L_R_bar_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}
	//Main Display Top and Bottom bars
	T_B_bar_surf = bitmap_surface("t & b bar.bmp");
	if(!T_B_bar_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	
//************ load the tile images **************************************
	terrains_surf[0] = bitmap_surface("terrain0.bmp", &rct);//&the rct gets the deminsions of the image
	if (!terrains_surf[0])
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}

	//set up the tile
	terrain[0].surf=terrains_surf[0];      
	terrain[0].blit_flags=DDBLTFAST_WAIT;
	terrain[0].width=rct.right;
	terrain[0].height=rct.bottom;




	terrains_surf[1] = bitmap_surface("terrain1.bmp", &rct);//&the rct gets the deminsions of the image
	if (!terrains_surf[1])
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}

	//set up the tile
	terrain[1].surf=terrains_surf[1];     
	terrain[1].blit_flags=DDBLTFAST_WAIT;
	terrain[1].width=rct.right;
	terrain[1].height=rct.bottom;





	terrains_surf[2] = bitmap_surface("terrain2.bmp", &rct);//&the rct gets the deminsions of the image
	if (!terrains_surf[2])
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}

	//set up the tile
	terrain[2].surf=terrains_surf[2];       
	terrain[2].blit_flags=DDBLTFAST_WAIT;
	terrain[2].width=rct.right;
	terrain[2].height=rct.bottom;





	// The Blanktile
	blanktile_surf = bitmap_surface("blanktile.bmp");//&the rct gets the deminsions of the image
	if (!blanktile_surf)
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}


	//The Unexplored Tile
	UnexploredTile_surf = bitmap_surface("UnexploredTile.bmp");//&the rct gets the deminsions of the image
	if (!UnexploredTile_surf)
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}

	//The Fog of War Tile
	FogOfWar_surf = bitmap_surface("FogOfWar.bmp");
	if (!FogOfWar_surf)
	{
		ErrStr=Err_LoadImageBackGround;
		return FALSE;
	}

//************************************************************************

//************************************************************************
//******** Image loading for the unit pics********************************


//************************************************************************
//---- Load Cursor Images -----//
	Cursor1_surf = bitmap_surface("cursor 1.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor1_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor2_surf = bitmap_surface("cursor 2.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor2_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor3_surf = bitmap_surface("cursor 3.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor3_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor4_surf = bitmap_surface("cursor 4.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor4_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor5_surf = bitmap_surface("cursor 5.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor5_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor6_surf = bitmap_surface("cursor 6.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor6_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor7_surf = bitmap_surface("cursor 7.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor7_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}

	Cursor8_surf = bitmap_surface("cursor 8.bmp", &rct);//&the rct gets the deminsions of the image
	if (!Cursor8_surf)
	{
		ErrStr=Err_LoadImage;
		return FALSE;
	}



	//get the pixel format
	DDPIXELFORMAT ddpf;
	ddpf.dwSize = sizeof(ddpf);
	lpDDSPrimary->GetPixelFormat (&ddpf);

	//Determine proper key for pixel format
	KeyColor = ddpf.dwGBitMask;        //the G is for pure green, which is the color that gets replaced

	//set the color key
	DDCOLORKEY key;
	key.dwColorSpaceLowValue = KeyColor;
	key.dwColorSpaceHighValue = KeyColor;



	terrains_surf[0]->SetColorKey(DDCKEY_SRCBLT, &key);
	terrains_surf[1]->SetColorKey(DDCKEY_SRCBLT, &key);
	terrains_surf[2]->SetColorKey(DDCKEY_SRCBLT, &key);
	blanktile_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	UnexploredTile_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	FogOfWar_surf->SetColorKey(DDCKEY_SRCBLT, &key);


	Cursor1_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor2_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor3_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor4_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor5_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor6_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor7_surf->SetColorKey(DDCKEY_SRCBLT, &key);
	Cursor8_surf->SetColorKey(DDCKEY_SRCBLT, &key);

	
	//green color - they fully cover up the images below them


	//return success to caller
	return TRUE;
}














//------ Function to Initialize DirectDraw/DirectInput and the Application ------//
static BOOL Init (HINSTANCE hInstance, int nCmdShow)
{
	WNDCLASS                    wc;
    HRESULT                     ddrval;
    LPDIRECTDRAW                pDD;


	// Set-up and resister window class
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;
	wc.lpfnWndProc		= (WNDPROC) WindowProc;
	wc.cbClsExtra		= 0;
	wc.cbWndExtra		= sizeof (DWORD);
	wc.hInstance		= hInstance;
	wc.hIcon			= NULL;
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground	= (HBRUSH) GetStockObject(BLACK_BRUSH);
    wc.lpszMenuName		= NULL;
    wc.lpszClassName	= szClass;

	if (!RegisterClass (&wc))
	{
		ErrStr=Err_Reg_Class;
		return FALSE;
	}


	
	// get dimensions of display
	int ScreenWidth = GetSystemMetrics (SM_CXSCREEN);
	int ScreenHeight = GetSystemMetrics (SM_CYSCREEN);


	// create a window and display

	hWnd = CreateWindow(szClass,				// class
						szCaption,				// caption
						WS_VISIBLE|WS_POPUP,	// sytle
						0,						// left
						0,						// top
						ScreenWidth,			// width
						ScreenHeight,			// height
						NULL,					// parent window
						NULL,					// menu
						hInstance,				// instance
						NULL);					// params

	if (!hWnd)
	{
		ErrStr = Err_Create_Win;
		return FALSE;
	}

	ShowWindow (hWnd, nCmdShow);
	UpdateWindow (hWnd);




    // Create the main DirectDraw object
    ddrval = DirectDrawCreate(NULL, &pDD, NULL);
    if (ddrval != DD_OK)
	{
		ErrStr = Err_DirectDrawCreate;
		return FALSE;
	}


    // Fetch DirectDraw4 interface
    ddrval = pDD->QueryInterface(IID_IDirectDraw4, (LPVOID *) & lpDD);
    if (ddrval != DD_OK) {
        ErrStr=Err_Query;
		return FALSE;
	}

	//set the cooperative level
	ddrval = lpDD->SetCooperativeLevel (hWnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN | DDSCL_ALLOWREBOOT);

	if (ddrval != DD_OK)
	{
		ErrStr = Err_Coop;
		return FALSE;
	}


	
	//set the display mode
	ddrval = lpDD->SetDisplayMode(x_resolution, y_resolution, color_depth, 0 ,0);
	if (ddrval != DD_OK)
	{
		ErrStr = Err_DispMode;
		return FALSE;
	}


////////////////////////////////////////////////////////////////////////
   // Create the primary surface
    DDSURFACEDESC2 ddsd;
	DDSCAPS2 ddscaps;
	ZeroMemory(&ddsd,sizeof(ddsd));
    ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
                          DDSCAPS_FLIP | 
                          DDSCAPS_COMPLEX;
    ddsd.dwBackBufferCount = 1;
    ddrval = lpDD->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
   
	if (ddrval!=DD_OK)
	{
		ErrStr=Err_CreatePrimarySurf;
		return FALSE;
	}


	// Create the primary back buffer interface
	ddscaps.dwCaps=DDSCAPS_BACKBUFFER;
	ddrval=lpDDSPrimary->GetAttachedSurface(&ddscaps,&lpDDSBack);
	if (ddrval!= DD_OK)
	{
		ErrStr=Err_CreateBackSurf;
		return FALSE;
	}
////////////////////////////////////////////////////////////////////////


	// load the images an set up the layers
	if (!load_images()) 
		return FALSE;	  // return with error if failed






	Game_Globals.bGameInitialized = TRUE;

	// return success to caller
	return TRUE;
}













	
	
	



 



//------ Application Loop ------//
int APIENTRY WinMain ( HINSTANCE hInstance,
					   HINSTANCE hPrevInstance,
					   LPSTR     lpCmdLine,
					   int		 nCmdShow)
{
	MSG msg;				// message from queue


	// initialize the application, exit on failure
	if (!Init (hInstance, nCmdShow))
	{
		MainGameCleanup();
		return FALSE;
	}

//************************************************************************
	MapGen();  //calls the function to generate the random map
	MapVariables();	
	UnitGen();
	//select the first player
	EndStrategicTurn();
	//select the first unit and center on it
	SelectNextUnit();
	CenterOnUnit();


//________________________________________________________________________________________
	// is there a performace counter available?
	LONGLONG Freq;
	LONGLONG NewTime;
	LONGLONG PreviousTime;
	bool bPerformanceCounter;


	if (QueryPerformanceFrequency(( LARGE_INTEGER *) &Freq))
	{
		QueryPerformanceCounter((LARGE_INTEGER *) &NewTime);
		bPerformanceCounter = TRUE;
	}
	else
	{
		NewTime=timeGetTime();
		Freq = 1000.0f;
		bPerformanceCounter = FALSE;
	}
//________________________________________________________________________________________


//----------------------------------------------------------------------------------------
//	Main Game Loop
//----------------------------------------------------------------------------------------
	// run till completed
	while (Game_Globals.bMainNotDone)
	{
		//is the mouse floating over a button still?
		GUI.MouseOver();
		


		//////////////////////////////////////////////////////////////////////////////////
		// has a keyboard key or mouse button been pressed?
		//////////////////////////////////////////////////////////////////////////////////
		if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))
		{
			// if yes, is it a quit message?
			if (msg.message == WM_QUIT)
				Game_Globals.bMainNotDone = FALSE;

			// dispatch the message
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		else
		{
			// use the appropriate method to get time 
			// and calculate elapsed time since last frame
			PreviousTime = NewTime;
			if (bPerformanceCounter) 
				QueryPerformanceCounter((LARGE_INTEGER *) &NewTime); 
			else 
				NewTime=timeGetTime(); 

			// calculate elapsed time
			DeltaTime = (NewTime - PreviousTime);
			DeltaTime /= Freq;
			if (DeltaTime < 0.0f)      //if its negative, make it positive
				DeltaTime *= -1.0f;
				
			
			// render the frame
			cRender_Frame.Render();

			
			//reset the this to zero after using it render the frame
			mouse_x_difference = 0;
			mouse_y_difference = 0;
		}
		//////////////////////////////////////////////////////////////////////////////////



	}
	// exit returning final message
	return (msg.wParam);
}




















